package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.*;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.apiservice.dao.IMesWorkOrderDao;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.print.IPrintTemplateStrategyService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.BeanMapUtilsExt;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.ext.mes.pojo.model.MesProduceSnPrintModel;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.mes.api.iservice.busi.ISyncFuncService;
import cn.estsh.i3plus.mes.apiservice.util.DateUtil;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.tool.MathOperation;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.codemaker.SnowflakeIdMaker;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.i3plus.pojo.mes.model.GenSerialNoModel;
import cn.estsh.i3plus.pojo.mes.model.MesWorkOrderModel;
import cn.estsh.i3plus.pojo.mes.repository.*;
import cn.estsh.i3plus.pojo.mes.util.DateUtilExt;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import cn.estsh.i3plus.pojo.model.wms.WmsProductModel;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.map.CaseInsensitiveMap;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;

@Service
@Slf4j
public class MesWorkOrderService extends BaseMesService<MesWorkOrder> implements IMesWorkOrderService {
    @Autowired
    private IMesWorkOrderLogService workOrderLogService;
    @Autowired
    private ISyncFuncService syncFuncService;
    @Autowired
    private IMesPartService iMesPartService;
    @Autowired
    private MesProductVersionRepository mesProductVersionRDao;
    @Autowired
    private IMesBomService mesBomService;
    @Autowired
    private IMesProductOffLineService mesProductOffLineService;
    @Autowired
    private IMesWorkOrderDao mesWorkOrderDao;
    @Autowired
    private MesWorkCenterRepository mesWorkCenterRDao;
    @Autowired
    private MesShiftRepository mesShiftRDao;
    @Autowired
    private IMesPartProdGroupService mesPartProdGroupService;
    @Autowired
    private MesCustomerPartRepository mesCustomerPartRDao;
    @Autowired
    private IMesMoveRuleService mesMoveRuleService;
    @Autowired
    private MesProdRuleSortCfgRepository mesProdRuleSortCfgRDao;
    @Autowired
    private IMesProdRuleNosortCfgService mesProdRuleNosortCfgService;
    @Autowired
    private IMesPartSapService mesPartSapService;
    @Autowired
    private MesMoveRepository mesMoveRDao;
    @Autowired
    private IMesWorkOrderToWmsService mesWorkOrderToWmsService;
    @Autowired
    private MesPartSapRepository mesPartSapRDao;
    @Autowired
    private MesPartProdGroupRepository mesPartProdGroupRDao;

    @Autowired
    private MesWorkOrderRepository workOrderRepository;

    @Autowired
    private MesProductOffLineRepository mesProductOffLineRDao;

    @Autowired
    private MesProduceSnRepository mesProduceSnRao;
    @Autowired
    private MesProductionRecordRepository productionRecordRao;
    @Autowired
    private MesWorkOrderLogRepository mesWorkOrderLogRepository;
    @Autowired
    private MesBomRepository mesBomRDao;
    @Autowired
    private MesPartRepository mesPartRDao;

    @Autowired
    private IMesWorkCenterService workCenterService;

    @Autowired
    private MesWorkCenterPartRelationRepository partRelationRao;

    @Autowired
    private IMesCcscTaskService mesCcscTaskService;

    @Autowired
    private MesWorkOrderToSapRepository mesWorkOrderToSapRepository;

    @Autowired
    private MesPrintQueueRepository printQueueRepository;

    @Autowired
    private MesCustomerCarModelRepository customerCarModelRepository;

    @Autowired
    private MesWorkOrderAssemblyRepository workOrderAssemblyRepository;

    @Autowired
    private IMesLabelTemplateService labelTemplateService;

    @Autowired
    private IMesPartProdGroupService partProdGroupService;

    @Autowired
    private IMesPrintedSnLogRepository printedSnLogRepository;

    @Autowired
    private SnowflakeIdMaker snowflakeIdMaker;

    @Autowired
    private MesPartPtrRepository partPtrRao;

    @Autowired
    private MesPartPtrDetailRepository partPtrDetailRao;

    @Autowired
    private MesWorkOrderPartRepository workOrderPartRao;

    @Autowired
    private MesProdRuleSortCfgRepository mesProdRuleSortCfgRao;

    @Autowired
    private MesQueueOrderRepository queueOrderRao;

    @Autowired
    private IMesWorkOrderAssemblyService mesWorkOrderAssemblyService;

    @Autowired
    private IMesWorkOrderPartService mesWorkOrderPartService;

    @Autowired
    private IMesProduceSnService mesProduceSnService;

    @Autowired
    private IMesConfigService mesConfigService;

    @Autowired
    private IMesProductVersionService mesProductVersionService;

    @Override
    public MesWorkOrder insert(MesWorkOrder bean) {
        // 数据校验
        ValidatorBean.checkNotNull(bean.getWorkOrderType(), "工单类型不能为空");
        ValidatorBean.checkNotNull(bean.getWorkCenterCode(), "产线不能为空");
        ValidatorBean.checkNotNull(bean.getPartNo(), "零件号不能为空");
        ValidatorBean.checkNotNull(bean.getShiftCode(), "班次不能为空");
        //校验产线与工位的关系
        boolean relationResult = checkWorkCenterPartRelation(bean.getWorkCenterCode(), bean.getPartNo());
        if (!relationResult && (StringUtil.isEmpty(bean.getOrderFlag()) || !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(bean.getOrderFlag()))){
            MesException.throwMesBusiException(String.format("工单产线【%s】与工单零件【%s】没有维护产线零件关系",bean.getWorkCenterCode(),bean.getPartNo()));
        }
        //排序生成个数 默认1，数量为生成工单的个数
        Double generateQty = bean.getQty();
        MesWorkCenter mesWorkCenter = workCenterService.getWorkCenterDb(bean.getOrganizeCode(), bean.getWorkCenterCode());
        if (Objects.isNull(mesWorkCenter)) {
            MesException.throwMesBusiException("产线【%s】不存在", bean.getWorkCenterCode());
        }
        bean.setErpWorkCenter(mesWorkCenter.getErpWorkCenter());
        bean.setAreaCode(mesWorkCenter.getAreaCode());
        //客户物料信息
        if (StringUtil.isEmpty(bean.getCustPartNo())) {
            getCustomerPart(bean);
        }
        //排序
        if (bean.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.SORT.getValue()) {
            insertSortWorkOrderNo(bean, mesWorkCenter);
            //生成数量大于1
            if (generateQty > 1) {
                insertBatchWorkOrder(bean, generateQty);
            }
            //非排序
        } else if (bean.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue()) {
            insertUnSortWorkOrder(bean, mesWorkCenter);
            //bto
        } else {
            insertBtoWorkOrder(bean);
        }
        return bean;
    }

    @Override
    public MesWorkOrder update(MesWorkOrder bean) {
        MesWorkOrder result = getMesWorkOrder(bean.getWorkOrderNo(),bean.getOrganizeCode());
        //若工单类型为排序 则根据排序插入工单数量插入多行 工单数量为1
        if (result.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.SORT.getValue()) {
            if (!Objects.equals(bean.getQty(), result.getQty())) {
                MesException.throwMesBusiException(String.format("工单类型为【%s】 不需要修改数量",
                        MesExtEnumUtil.ORDER_TYPE.SORT.getDescription()));
            }
        } else {
            //更新工单数量
            if (!bean.getQty().equals(result.getQty()) && result.getWorkOrderStatus() > MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue()) {
                MesException.throwMesBusiException(String.format("工单状态为【%s】不允许更新工单数量", MesExtEnumUtil.ORDER_STATUS.valueOfDescription(result.getWorkOrderStatus())));
            } else {
                result.setQty(bean.getQty());
                result.setUnCompleteQty(MathOperation.sub(bean.getQty(), result.getReportedQty()));
            }
        }
        //在加工的工单不能修改物料信息
        if (result.getWorkOrderStatus() >= MesExtEnumUtil.ORDER_STATUS.PROCESS.getValue()) {
            if (!Objects.equals(bean.getPartNo(), result.getPartNo())) {
                MesException.throwMesBusiException(String.format("工单状态为【%s】不允许修改物料",
                        MesExtEnumUtil.ORDER_STATUS.valueOfDescription(result.getWorkOrderStatus())));
            }
        }

        boolean isSavePrintQueue = false;

        //更新状态
        if (result.getWorkOrderStatus().intValue() != bean.getWorkOrderStatus().intValue()) {

            // 发布时创建工单打印队列
            if (!Objects.equals(bean.getWorkOrderStatus(), result.getWorkOrderStatus()) && bean.getWorkOrderStatus() == MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue()) {
                isSavePrintQueue = true;
            }
            //排序工单 关闭工单对列表
            if (!Objects.equals(bean.getWorkOrderStatus(), result.getWorkOrderStatus()) && MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue() == bean.getWorkOrderStatus() && MesExtEnumUtil.ORDER_TYPE.SORT.getValue() == bean.getWorkOrderType()) {
                closeMesQueueOrder(bean.getWorkOrderNo(), bean.getOrganizeCode(), AuthUtilExt.getUserName());
            }
            result.setWorkOrderStatus(bean.getWorkOrderStatus());
        }

        updateMesWorkOrder(result,MesExtEnumUtil.WORK_ORDER_LOG_TYPE.UPDATE,0);
        if (isSavePrintQueue) insertPrintQueue(result);

        return result;
    }


    @Override
    protected void setPackQueryBean(MesWorkOrder bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getWorkOrderNo(), "workOrderNo", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPartName(), "partName", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getCreateUser(), "createUser", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPartNo(), "partNo", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getCustPartNo(), "custPartNo", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getWorkCenterCode(), "workCenterCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getVinCode(), "vinCode", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getOrderFlag(), "orderFlag", packBean);
        if (!StringUtil.isEmpty(bean.getWorkOrderStatusQuery())) {
            DdlPreparedPack.getInPackList(Arrays.stream(bean.getWorkOrderStatusQuery().split(MesExtConstWords.COMMA)).map(Integer::parseInt).collect(Collectors.toList()), "workOrderStatus", packBean);
        } else DdlPreparedPack.getNumEqualPack(bean.getWorkOrderStatus(), "workOrderStatus", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getWorkOrderType(), "workOrderType", packBean);
        DdlPreparedPack.getStringBiggerPack(bean.getCreateDateTimeStart(), "createDatetime", packBean);
        DdlPreparedPack.getStringSmallerPack(bean.getCreateDateTimeEnd(), "createDatetime", packBean);
        DdlPreparedPack.getStringBiggerPack(bean.getStartTimeStart(), "planStartTime", packBean);
        DdlPreparedPack.getStringSmallerPack(bean.getStartTimeEnd(), "planStartTime", packBean);
        DdlPreparedPack.getStringBiggerPack(bean.getEndTimeStart(), "planEndTime", packBean);
        DdlPreparedPack.getStringSmallerPack(bean.getEndTimeEnd(), "planEndTime", packBean);
        packBean.setOrderByStr(" order by createDatetime desc,workOrderSeq asc,productSeq asc,workOrderNo asc ");
    }

    @Override
    protected void setBeanModel(List<MesWorkOrder> mesWorkOrderList) {
        //查询工作中心名称
        if (CollectionUtils.isEmpty(mesWorkOrderList)) {
            return;
        }
        MesWorkOrder mesWorkOrder = mesWorkOrderList.iterator().next();
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(mesWorkOrder.getOrganizeCode());
        DdlPreparedPack.getInPackList(mesWorkOrderList.stream().map(MesWorkOrder::getWorkCenterCode).filter(workCenterCode -> !StringUtils.isEmpty(workCenterCode)).distinct().collect(Collectors.toList()), "workCenterCode", ddlPackBean);
        List<MesWorkCenter> mesWorkCenterList = mesWorkCenterRDao.findByHqlWhere(ddlPackBean);
        if (CollectionUtils.isEmpty(mesWorkCenterList)) {
            return;
        }
        Map<String, String> mesWorkCenterMap = mesWorkCenterList.stream().collect(Collectors.toMap(MesWorkCenter::getWorkCenterCode, MesWorkCenter::getWorkCenterName));
        mesWorkOrderList.forEach(t -> {
            t.setWorkCenterName(mesWorkCenterMap.get(t.getWorkCenterCode()));
        });

    }

    private String getOrderNo(MesWorkOrder item) {
        String orderNo;
        if(item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.SORT.getValue()){
            GenSerialNoModel genSerialNoModel = new GenSerialNoModel("MES_WORK_ORDER_NO_WU_HAN");
            List<String> resultList = syncFuncService.syncSerialNo(genSerialNoModel.organizeCode(item.getOrganizeCode()),  item.getCreateUser(), item.getOrganizeCode(), 1).getResultList();
            String serialNo = resultList.get(0).replace("MES_WORK_ORDER_NO_WU_HAN", "");
            orderNo = item.getOrganizeCode() + item.getOrderFlag() + item.getShiftCode() + serialNo;
        }else if(item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.BTO.getValue()){
            GenSerialNoModel genSerialNoModel = new GenSerialNoModel(MesCommonConstant.MES_WORK_CENTER_ORDER_NO);
            genSerialNoModel.setPartNo(item.getWorkCenterCode());
            orderNo = (String)syncFuncService.syncSerialNo(genSerialNoModel.organizeCode(item.getOrganizeCode()), item.getCreateUser(), item.getOrganizeCode(), 1).getResultList().get(0);
        }else {
            GenSerialNoModel genSerialNoModel = new GenSerialNoModel(MesCommonConstant.MES_WORK_ORDER_NO);
            orderNo = (String)syncFuncService.syncSerialNo(genSerialNoModel.organizeCode(item.getOrganizeCode()), item.getCreateUser(), item.getOrganizeCode(), 1).getResultList().get(0);
        }
        DdlPackBean orderPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(orderNo, "workOrderNo", orderPackBean);
        if (baseRDao.isExitByHql(orderPackBean)) {
            MesException.throwMesBusiException("单号流水码生成重复");
        }
        return orderNo;
    }

    private void insertMesWorkOrder(MesWorkOrder item, List<MesWorkOrderPart> orderPartList) {
        /**
         * 总成拆bom,变成子零件
         * 替换子零件，通过替换后的零件，去找排序工艺
         */
        Map<String,String> ptrRuleListMap = new HashMap<>();
        //是否修改为P单
        boolean isModifyPOrder = false;
        //查询mes_part_ptr表，根据物料清单查找ptr替换信息
        if (!CollectionUtils.isEmpty(orderPartList)){
            Map<String, MesWorkOrderPart> orderPartMap = orderPartList.stream().collect(Collectors.toMap(MesWorkOrderPart::getPartNo, Function.identity()));
            //先替换客户的ptr信息
            String ptrInfo = item.getPtrInfo();
            if (!StringUtils.isEmpty(ptrInfo)) {
                List<String> ptrInfoList = Arrays.asList(ptrInfo.replace("_", "").split("\\|"));
                if (!ptrInfoList.isEmpty()){
                    List<MesPartPtr> custPartPtrList = getCustPartPtrList(ptrInfoList, item.getOrganizeCode());
                    for (MesPartPtr mesPartPtr : custPartPtrList) {
                        //根据mesPartPtr的目标零件号，找到零件信息
                        String destPartNo = mesPartPtr.getDestPartNo();
                        MesPartSap mesPartSap = mesPartSapService.getMesPartSapByPartNo(destPartNo, item.getOrganizeCode());
                        //更新物料清单
                        MesWorkOrderPart orderPart = orderPartMap.get(destPartNo);
                        if (orderPart != null) {
                            orderPart.setPartNo(mesPartSap.getPartNo());
                            orderPart.setPartName(mesPartSap.getPartName());
                            orderPart.setShippingPartNo(mesPartSap.getPartNo());
                            if (!isModifyPOrder){
                                isModifyPOrder = true;
                            }
                        }
                    }
                }
            }
            List<String> partNoList = orderPartList.stream().map(MesWorkOrderPart::getPartNo).collect(Collectors.toList());
            List<MesPartPtr> partPtrList = getPartPtrList(item.getOrganizeCode(), item.getWorkCenterCode(), partNoList);
            //装配件规则如果进行了零件替换 则使用ptr的规则 key 零件号，value 是规则

            for (MesPartPtr mesPartPtr : partPtrList) {
                //根据mesPartPtr的目标零件号，找到零件信息
                String destPartNo = mesPartPtr.getDestPartNo();
                String srcPartNo = mesPartPtr.getSrcPartNo();
                MesPartSap mesPartSap = mesPartSapService.getMesPartSapByPartNo(destPartNo, item.getOrganizeCode());
                //更新物料清单
                MesWorkOrderPart orderPart = orderPartMap.get(srcPartNo);
                if (orderPart != null) {
                    orderPart.setPartNo(mesPartSap.getPartNo());
                    orderPart.setPartName(mesPartSap.getPartName());
                    orderPart.setShippingPartNo(mesPartSap.getPartNo());
                    ptrRuleListMap.put(mesPartSap.getPartNo(), mesPartPtr.getReplacePartSnRule());
                    if (!isModifyPOrder){
                        isModifyPOrder = true;
                    }
                    //更新mes_part_ptr的实际数量 + 1
                    mesPartPtr.setPrtVehicleActualCount(mesPartPtr.getPrtVehicleActualCount() + 1);
                    ConvertBean.saveOrUpdate(mesPartPtr, item.getModifyUser());
                    partPtrRao.update(mesPartPtr);
                    DdlPackBean partPtrDetailPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
                    DdlPreparedPack.getNumEqualPack(mesPartPtr.getId(),"ptrId",partPtrDetailPackBean);
                    DdlPreparedPack.getStringEqualPack(item.getPartNo(),"totalPartNo",partPtrDetailPackBean);
                    List<MesPartPtrDetail> partPtrDetailList = partPtrDetailRao.findByHqlWhere(partPtrDetailPackBean);
                    if (!partPtrDetailList.isEmpty()){
                        MesPartPtrDetail mesPartPtrDetail = partPtrDetailList.get(0);
                        mesPartPtrDetail.setQty(mesPartPtrDetail.getQty() + 1);
                        ConvertBean.saveOrUpdate(mesPartPtrDetail, item.getModifyUser());
                        partPtrDetailRao.update(mesPartPtrDetail);
                    }
                    //更新mes_part_ptr_detail 的workOrder.partNo  数量加 1 ;替换了几次还是什么
                }
            }
        }

        //  生成装配件清单
        if (isModifyPOrder){
            item.setOrderFlag(MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.PTR.getValue());
        }

        if (!CollectionUtils.isEmpty(orderPartList)) {
            for (MesWorkOrderPart orderPart : orderPartList) {
                orderPart.setOrganizeCode(item.getOrganizeCode());
                orderPart.setWorkOrderNo(item.getWorkOrderNo());
                ConvertBean.saveOrUpdate(orderPart, item.getModifyUser());
            }
            workOrderPartRao.saveAll(orderPartList);
        }
        List<MesWorkOrderAssembly> assemblyList = getAssemblyList(item.getWorkCenterCode(), item.getCarModelCode(), orderPartList, item.getOrganizeCode());
        if (!CollectionUtils.isEmpty(assemblyList)) {
            for (MesWorkOrderAssembly orderAssembly : assemblyList) {
                if (ptrRuleListMap.get(orderAssembly.getPartNo()) != null){
                    orderAssembly.setMatchRule(ptrRuleListMap.get(orderAssembly.getPartNo()));
                }
                orderAssembly.setPartNo(item.getPartNo());
                orderAssembly.setPartName(item.getPartName());
                orderAssembly.setWorkOrderNo(item.getWorkOrderNo());
                orderAssembly.setAssemblyStatus(MesExtEnumUtil.ASSEMBLY_STATUS.ASSEMBLY_STATUS_30.getValue());
                orderAssembly.setOrganizeCode(item.getOrganizeCode());
                orderAssembly.setProductSn(item.getWorkOrderNo());
                orderAssembly.setAreaCode(item.getAreaCode());
                ConvertBean.saveOrUpdate(orderAssembly, item.getCreateUser());
            }
            workOrderAssemblyRepository.saveAll(assemblyList);

            List<String> cellCodeList = assemblyList.stream().map(MesWorkOrderAssembly::getWorkCellCode).distinct().collect(Collectors.toList());
            Map<String, List<MesWorkOrderAssembly>> cellCodeMap = assemblyList.stream().collect(Collectors.groupingBy(MesWorkOrderAssembly::getWorkCellCode));
            for (String cellCode : cellCodeList) {
                MesQueueOrder mesQueueOrder = new MesQueueOrder();
                BeanUtils.copyProperties(item,mesQueueOrder,MesExtConstWords.ID,MesExtConstWords.SYSTEM_SYNC_STATUS);
                mesQueueOrder.setWorkCellCode(cellCode);
                mesQueueOrder.setProcessSeq(cellCodeMap.get(cellCode).get(0).getProcessSeq());
                mesQueueOrder.setSerialNumber(item.getWorkOrderNo());
                mesQueueOrder.setProductSn(item.getWorkOrderNo());
                mesQueueOrder.setStatus(MesExtEnumUtil.QUEUE_ORDER_STATUS.CREATE.getValue());
                ConvertBean.saveOrUpdate(mesQueueOrder, item.getCreateUser());
                queueOrderRao.insert(mesQueueOrder);
            }
        }

        //生成条码表
        MesProduceSn mesProduceSn = new MesProduceSn();
        mesProduceSn.setProductSn(item.getWorkOrderNo());
        mesProduceSn.setCustSn(item.getCustSn());
        mesProduceSn.setWorkOrderNo(item.getWorkOrderNo());
        mesProduceSn.setOrganizeCode(item.getOrganizeCode());
        mesProduceSn.setFid(UUID.randomUUID().toString());
        mesProduceSn.setCustCode(item.getCustCode());
        mesProduceSn.setCustPartNo(item.getCustPartNo());
        mesProduceSn.setPartNo(item.getPartNo());
        mesProduceSn.setPartName(item.getPartName());
        mesProduceSn.setShiftCode(item.getShiftCode());
        mesProduceSn.setWorkCenterCode(item.getWorkCenterCode());
        mesProduceSn.setPrintStatus(MesExtEnumUtil.PRINT_STATUS.UNPRINT.getValue());
        mesProduceSn.setQcStatus(MesExtEnumUtil.PRODUCE_QC_STATUS.QUALIFIED.getValue());
        mesProduceSn.setQty(1.0);
        mesProduceSn.setSerialNumber(item.getWorkOrderNo());
        mesProduceSn.setSnStatus(MesExtEnumUtil.PRODUCE_SN_STATUS.CREATE.getValue());
        mesProduceSn.setSnType(MesExtEnumUtil.PRODUCE_SN_TYPE.STANDARD.getValue());
        mesProduceSn.setFid(UUID.randomUUID().toString());
        mesProduceSn.setAreaCode(item.getAreaCode());
        ConvertBean.saveOrUpdate(mesProduceSn, item.getCreateUser());
        mesProduceSnRao.insert(mesProduceSn);
    }

    private List<MesWorkOrderPart> autoPublish(MesWorkOrder item) {
        //非试制单
        MesProductVersion mesProductVersion = null;
        if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(item.getOrderFlag())) {
            //获取生产版本
            mesProductVersion = getMesProductVersion(item.getOrganizeCode(),item.getPartNo());
            item.setProductVersion(mesProductVersion.getProductVersion());
        }
        //是否自动发布
        return isAuto(item, mesProductVersion);
    }

    private List<MesWorkOrderPart> isAuto(MesWorkOrder item,MesProductVersion mesProductVersion) {
        MesPartProdGroup mesPartProdGroup = null;
        if(StringUtil.isEmpty(item.getPartProdGroupCode())){
            mesPartProdGroup = getMesPartProdGroup(item);
        }else{
            DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
            DdlPreparedPack.getStringEqualPack(item.getPartProdGroupCode(), "partProdGroupCode", ddlPackBean);
            mesPartProdGroup = mesPartProdGroupRDao.getByProperty(ddlPackBean);
            if(Objects.isNull(mesPartProdGroup)){
                MesException.throwMesBusiException("零件生产组【%s】信息不存在",item.getPartProdGroupCode());
            }
        }
        item.setPartProdGroupCode(mesPartProdGroup.getPartProdGroupCode());
        item.setPartProdGroupName(mesPartProdGroup.getPartProdGroupName());
        item.setCustCode(mesPartProdGroup.getCustCode());

        //自动发布
        if (CommonEnumUtil.VALID == mesPartProdGroup.getIsAutoRelease()) {
            item.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue());
            // 创建工单打印队列
            insertPrintQueue(item);
        } else {
            item.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.CREATE.getValue());
        }

        // 打散bom
        List<MesWorkOrderPart> workOrderPartList = new ArrayList<>();
        if (mesPartProdGroup.getIsDisassembleBom() == CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue() && !Objects.isNull(mesProductVersion)) {
            workOrderPartList = dismantleBom(findBomList(item.getOrganizeCode(), iMesPartService.getPartByPartNo(item.getPartNo(), item.getOrganizeCode()),mesProductVersion.getAlternativePartList()), item.getQty(), item.getOrganizeCode(), item.getWorkCellCode(), item.getWorkOrderNo());
        }
        return workOrderPartList;
    }

    private MesPrintQueue insertPrintQueue(MesWorkOrder workOrder) {

        if (workOrder.getWorkOrderType() != MesExtEnumUtil.ORDER_TYPE.SORT.getValue()) return null;

        if (workOrder.getWorkOrderStatus() != MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue()) return null;

        MesPrintQueue printQueue = new MesPrintQueue();
        BeanUtils.copyProperties(workOrder, printQueue, MesExtConstWords.ID);
        printQueue.setPrintQueueType(MesExtEnumUtil.PRINT_QUEUE_TYPE.WORK_ORDER_ASSEMBLY.getValue());
        printQueue.setPrintStatus(MesExtEnumUtil.PRINT_STATUS.UNPRINT.getValue());
        return printQueueRepository.save(printQueue);
    }

    private MesPartProdGroup getMesPartProdGroup(MesWorkOrder item) {
        MesPartProdGroupDetail mesPartProdGroupDetail = new MesPartProdGroupDetail();
        mesPartProdGroupDetail.setWorkCenterCode(item.getWorkCenterCode());
        mesPartProdGroupDetail.setProductPartNo(item.getPartNo());
        mesPartProdGroupDetail.setOrganizeCode(item.getOrganizeCode());
        List<MesPartProdGroup> mesPartProdGroupList = mesPartProdGroupService.findMesPartProdGroup(mesPartProdGroupDetail);
        if (CollectionUtils.isEmpty(mesPartProdGroupList)) {
            MesException.throwMesBusiException("生产线代码【%s】零件号【%s】对应的零件生产组信息没有维护",
                    item.getWorkCenterCode(), item.getPartNo());
        }
        return mesPartProdGroupList.iterator().next();
    }

    private void getCustomerPart(MesWorkOrder item) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPartNo(), "erpPartNo", ddlPackBean);
        MesCustomerPart customerPart = mesCustomerPartRDao.getByProperty(ddlPackBean);
        if (!Objects.isNull(customerPart)) {
            item.setCustPartNo(customerPart.getCustPartNo());
        }
    }

    private void packPlanTime(MesWorkOrder item, Map<String, List<MesShift>> mesShiftMap) {
        ValidatorBean.checkNotNull(item.getPlanDate(), "计划日期不能为空");
        ValidatorBean.checkNotNull(item.getShiftCode(), "班次不能为空");
        //工单导入：计划时间不能为当天之前日期
        try {
            if (DateUtilExt.compareDateTime(DateUtil.SHORT_FORMAT, item.getPlanDate(), TimeTool.getToday()) < 0) {
                MesException.throwMesBusiException("导入工单计划日期不能小于今天");
            }
        } catch (ImppBusiException busExcep) {
            MesException.throwMesBusiException(busExcep.getErrorDetail());
        } catch (Exception e) {
            MesException.throwMesBusiException("计划日期格式异常，日期格式应为:%s",DateUtil.SHORT_FORMAT);
        }
        //查询班次信息
        List<MesShift> mesShifts = mesShiftMap.get(item.getWorkCenterCode() + item.getShiftCode());
        MesShift mesShift = CollectionUtils.isEmpty(mesShifts) ? null : mesShifts.iterator().next();
        if (Objects.isNull(mesShift)) {
            MesException.throwMesBusiException("产线【%s】班次【%s】信息不存在", item.getWorkCenterCode(), item.getShiftCode());
        }
        item.setShiftName(mesShift.getShiftName());
        try {
            //拼接
            item.setPlanStartTime(TimeTool.parseStringFormat(item.getPlanDate() + " " + mesShift.getStartTime(),DateUtil.BASE_FORMAT1,DateUtil.BASE_FORMAT));
            item.setPlanEndTime(TimeTool.parseStringFormat(item.getPlanDate() + " " + mesShift.getEndTime(),DateUtil.BASE_FORMAT1,DateUtil.BASE_FORMAT));
            int windowStartEndTimeCompare = DateUtilExt.compareDateTime(DateUtil.BASE_FORMAT, item.getPlanStartTime(), item.getPlanEndTime());
            if (windowStartEndTimeCompare > 0) {
                item.setPlanEndTime(TimeTool.pareDateToString(DateUtil.addDays(item.getPlanEndTime(), 1)));
            }
        } catch (Exception e) {
            MesException.throwMesBusiException("时间格式异常");
        }
        item.setProduceTime(item.getPlanDate());
        item.setProductTime(item.getProduceTime());
    }

    @Override
    public ListPager<MesProductVersion> queryMesProductVersionByPager(MesProductVersion mesProductVersion, Pager pager) {
        DdlPackBean productVersionQueryPackBean = DdlPackBean.getDdlPackBean(mesProductVersion.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(mesProductVersion.getPartNo(), "partNo", productVersionQueryPackBean);
        DdlPreparedPack.getStringEqualPack(mesProductVersion.getWorkCenterCode(), "workCenterCode", productVersionQueryPackBean);
        pager = PagerHelper.getPager(pager, mesProductVersionRDao.findByHqlWhereCount(productVersionQueryPackBean));
        List<MesProductVersion> mesProductVersions = mesProductVersionRDao.findByHqlWherePage(productVersionQueryPackBean, pager);
        return new ListPager<>(mesProductVersions, pager);
    }

    @Override
    public void saveMesWorkOrderExcel(List<MesWorkOrder> mesWorkOrderList) {
        MesWorkOrder next = mesWorkOrderList.iterator().next();
        //属性校验&字段填充
        checkData(mesWorkOrderList, next.getOrganizeCode());
        //BTO序号
        List<String> seqList = new ArrayList<>();
        if (MesExtEnumUtil.ORDER_TYPE.BTO.getValue() == next.getWorkOrderType()) {
            GenSerialNoModel orderSeqSerialNoModel = new GenSerialNoModel(MesCommonConstant.ORDER_NO_BTO_SEQ);
            seqList = syncFuncService.syncSerialNo(orderSeqSerialNoModel.organizeCode(next.getOrganizeCode()), next.getCreateUser(), next.getOrganizeCode(), mesWorkOrderList.size()).getResultList();
        }
        List<MesWorkOrderLog> mesWorkOrderLogList = new ArrayList<>();
        int index = 0;
        for (MesWorkOrder item : mesWorkOrderList) {
            //获取相同类型 相同标识 生产序号最大值的
            DdlPackBean orderPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
            DdlPreparedPack.getNumEqualPack(item.getWorkOrderStatus(), "workOrderStatus", orderPackBean);
            DdlPreparedPack.getStringEqualPack(item.getOrderFlag(), "orderFlag", orderPackBean);
            DdlPreparedPack.getOrderByPack(new Object[]{CommonEnumUtil.ASC_OR_DESC.DESC.getValue()}, new String[]{"productSeq"}, orderPackBean);
            MesWorkOrder result = baseRDao.getByProperty(orderPackBean);

            //若工单类型为排序 则根据排序插入工单数量插入多行 工单数量为1
            if (item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.SORT.getValue()) {
                Long productSeq = 0L;
                if (null != result && result.getProductSeq() != null) {
                    productSeq = (long) Math.toIntExact(result.getProductSeq());
                }
                MesWorkOrder copyMesWorkOrder = new MesWorkOrder();
                BeanUtils.copyProperties(item, copyMesWorkOrder);
                copyMesWorkOrder.setProductSeq(productSeq + 1);
                copyMesWorkOrder.setSystemSyncStatus(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
                ConvertBean.serviceModelInitialize(copyMesWorkOrder, item.getCreateUser());
                index++;
                baseRDao.insert(copyMesWorkOrder);
                //保存记录
                MesWorkOrderLog workOrderLog = new MesWorkOrderLog();
                BeanUtils.copyProperties(item, workOrderLog,MesExtConstWords.ID,MesExtConstWords.SYSTEM_SYNC_STATUS);
                mesWorkOrderLogList.add(workOrderLog);

                // 如果工单为发布状态则新增打印队列
                insertPrintQueue(copyMesWorkOrder);

                continue;
            } else if (item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.BTO.getValue()) {
                Long productSeq = 0L;
                if (null != result && result.getProductSeq() != null) {
                    //productSeq = (long) Math.toIntExact(result.getProductSeq());
                    productSeq = result.getProductSeq();
                }
                item.setProductSeq(productSeq + 1);
                item.setWorkOrderSeq(seqList.get(index));
            }
            item.setSystemSyncStatus(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
            ConvertBean.serviceModelInitialize(item, item.getCreateUser());
            baseRDao.insert(item);
            index++;
            //保存记录
            MesWorkOrderLog workOrderLog = new MesWorkOrderLog();
            BeanUtils.copyProperties(item, workOrderLog,MesExtConstWords.ID,MesExtConstWords.SYSTEM_SYNC_STATUS);
            mesWorkOrderLogList.add(workOrderLog);
        }
        //保存工单记录
        if (CollectionUtils.isNotEmpty(mesWorkOrderLogList)) {
            workOrderLogService.insertBatch(mesWorkOrderLogList);
        }
    }

    private void checkData(List<MesWorkOrder> mesWorkOrderList, String organizeCode) {
        MesWorkOrder next = mesWorkOrderList.iterator().next();
        String nowDate = TimeTool.getNowTime(true);
        //获取产线信息
        List<String> workCenterCodeList = mesWorkOrderList.stream().map(MesWorkOrder::getWorkCenterCode).distinct().collect(Collectors.toList());
        List<MesWorkCenter> mesWorkCenterList = BeanMapUtilsExt.getBeanList(mesWorkCenterRDao, "workCenterCode", organizeCode, workCenterCodeList, "产线信息");
        //产线导入不区分大小小
        Map<String, MesWorkCenter> workCenterMap = new CaseInsensitiveMap();
        for (MesWorkCenter workCenter : mesWorkCenterList) {
            workCenterMap.put(workCenter.getWorkCenterCode(), workCenter);
        }
        //获取班次信息
        List<MesShift> mesShiftList = getMesShifts(organizeCode, nowDate, workCenterCodeList);
        Map<String, List<MesShift>> mesShiftMap = mesShiftList.stream().collect(Collectors.groupingBy(t -> t.getWorkCenterCode() + t.getShiftCode()));
        //获取生产版本
        List<String> partNoList = mesWorkOrderList.stream().map(MesWorkOrder::getPartNo).distinct().collect(Collectors.toList());
        List<MesProductVersion> mesProductVersionList = BeanMapUtilsExt.getBeanList(mesProductVersionRDao, "partNo", organizeCode, partNoList, "生产版本信息");
        //客户物料信息
        Map<String, MesCustomerPart> mesCustomerPartMap = null;
        try {
            mesCustomerPartMap = BeanMapUtilsExt.getBeanMap(mesCustomerPartRDao, "erpPartNo", organizeCode, partNoList, "客户物料信息");
        } catch (Exception e) {
        }
        //获取物料信息
        Map<String, MesPartSap> mesPartSapMap = BeanMapUtilsExt.getBeanMap(mesPartSapRDao, "partNo", organizeCode, partNoList, "物料信息");
        //获取获取vin号
        List<String> vinCodeList = mesWorkOrderList.stream().map(MesWorkOrder::getVinCode).filter(Objects::nonNull).distinct().collect(Collectors.toList());
        if (!CollectionUtils.isEmpty(vinCodeList)) {
            List<MesWorkOrder> mesWorkOrders = null;
            try {
                mesWorkOrders = BeanMapUtilsExt.getBeanList(baseRDao, "vinCode", organizeCode, vinCodeList, "生产工单");
            } catch (Exception e) {
            }
            if (!CollectionUtils.isEmpty(mesWorkOrders)) {
                List<String> list = mesWorkOrders.stream().map(MesWorkOrder::getVinCode).collect(Collectors.toList());
                MesException.throwMesBusiException("vin号【%s】已存在", list);
            }
        }
        //生成工单号
        List<String> orderList=new ArrayList<>();
        Map<String, List<MesProductVersion>> mesProductVersionMap =null;
        if(next.getWorkOrderType() != MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue()){
            mesProductVersionMap = mesProductVersionList.stream().collect(Collectors.groupingBy(t ->  t.getPartNo()));
            GenSerialNoModel genSerialNoModel = new GenSerialNoModel(MesCommonConstant.MES_WORK_CENTER_ORDER_NO);
            genSerialNoModel.setPartNo(next.getWorkCenterCode());
            orderList = syncFuncService.syncSerialNo(genSerialNoModel.organizeCode(next.getOrganizeCode()), next.getCreateUser(), next.getOrganizeCode(), mesWorkOrderList.size()).getResultList();
        }else {
            mesProductVersionMap = mesProductVersionList.stream().collect(Collectors.groupingBy(MesProductVersion::getPartNo));
            GenSerialNoModel genSerialNoModel = new GenSerialNoModel(MesCommonConstant.MES_WORK_ORDER_NO);
            orderList = syncFuncService.syncSerialNo(genSerialNoModel.organizeCode(next.getOrganizeCode()), next.getCreateUser(), next.getOrganizeCode(), mesWorkOrderList.size()).getResultList();
        }
        //查询工单是否已经存在
        DdlPackBean orderPackBean = DdlPackBean.getDdlPackBean(next.getOrganizeCode());
        DdlPreparedPack.getInPackList(orderList, "workOrderNo", orderPackBean);
        if (baseRDao.isExitByHql(orderPackBean)) {
            MesException.throwMesBusiException("单号已存在");
        }
        //vin号
        Map<String, String> vinCodeMap = new HashMap<>();
        //零件生产组
        Map<String, MesPartProdGroup> mesPartProdGroupMap = new HashMap<>();
        int index = 0;
        for (MesWorkOrder item : mesWorkOrderList) {
            item.setWorkOrderNo(orderList.get(index));
            // 数据校验
            ValidatorBean.checkNotNull(item.getWorkOrderType(), "工单类型不能为空");
            ValidatorBean.checkNotNull(item.getWorkCenterCode(), "产线不能为空");
            ValidatorBean.checkNotNull(item.getPartNo(), "零件号不能为空");

            MesWorkCenter mesWorkCenter = workCenterMap.get(item.getWorkCenterCode());

            if (Objects.isNull(mesWorkCenter)) {
                MesException.throwMesBusiException("产线【%s】不存在", item.getWorkCenterCode());
            }
            item.setWorkCenterCode(mesWorkCenter.getWorkCenterCode());
            item.setErpWorkCenter(mesWorkCenter.getErpWorkCenter());
            //校验产线零件是否存在
            if (!checkWorkCenterPartRelation(item.getWorkCenterCode(),item.getPartNo()) && (StringUtil.isEmpty(item.getOrderFlag()) || !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(item.getOrderFlag()))){
                MesException.throwMesBusiException(String.format("工单产线【%s】与工单零件【%s】没有维护产线零件关系",mesWorkCenter.getWorkCenterCode(),item.getPartNo()));
            }
            //获取客户物料信息
            MesCustomerPart customerPart = null == mesCustomerPartMap ? null : mesCustomerPartMap.get(item.getPartNo());
            if (!Objects.isNull(customerPart)) {
                item.setCustPartNo(customerPart.getCustPartNo());
                item.setCustomerPartName(customerPart.getCustPartName());
            }
            //物料名称不存在，从物料信息中获取
            MesPartSap mesPart = mesPartSapMap.get(item.getPartNo());
            if (Objects.isNull(mesPart)) {
                MesException.throwMesBusiException("物料【%s】信息不存在", item.getPartNo());
            }
            item.setPartName(mesPart.getPartName());
            item.setUnit(mesPart.getUnit());
            //生产时间新增取当天
            if (StringUtil.isEmpty(item.getProduceTime())) {
                item.setProduceTime(TimeTool.getToday());
                item.setProductTime(item.getProduceTime());
            }
            //若工单类型为排序
            if (item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.SORT.getValue()) {
                ValidatorBean.checkNotNull(item.getShiftCode(), "班次不能为空");
                ValidatorBean.checkNotNull(item.getOrderFlag(), "标识不能为空");
                //校验产线类型和工单类型是否匹配
                if (!Objects.equals(mesWorkCenter.getCenterType(), MesExtEnumUtil.ORDER_TYPE.SORT.getValue())) {
                    MesException.throwMesBusiException("产线【%s】类型为【%s】，请选择排序产线", mesWorkCenter.getWorkCenterCode(),
                            MesExtEnumUtil.WORK_CENTER_TYPE.valueOfDescription(mesWorkCenter.getCenterType()));
                }
                //若工单类型为排序 标识为 N E P S
                if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue().equals(item.getOrderFlag()) &&
                        !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue().equals(item.getOrderFlag()) &&
                        !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.S.getValue().equals(item.getOrderFlag()) &&
                        !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(item.getOrderFlag())) {
                    MesException.throwMesBusiException(String.format("工单标识为【%s】请选择 【%s】、【%s】、【%s】、【%s】 标识",
                            item.getOrderFlag(), MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue()
                            , MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue(),
                            MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.S.getValue(),
                            MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue()));
                }
                //计划开始时间，计划结束时间拼接
                packPlanTime(item, mesShiftMap);
                //校验vin号
                if (!StringUtil.isEmpty(item.getVinCode())) {
                    if (vinCodeMap.containsKey(item.getVinCode())) {
                        MesException.throwMesBusiException("vin号【%s】重复", item.getVinCode());
                    } else {
                        vinCodeMap.put(item.getVinCode(), item.getVinCode());
                    }
                }
                //排序工单数量为1
                item.setQty(1d);
                //自动发布
                autoPublish(mesProductVersionMap, mesPartProdGroupMap, item, mesWorkCenter);
            } else if (item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue()) {
                ValidatorBean.checkNotNull(item.getShiftCode(), "班次不能为空");
                ValidatorBean.checkNotNull(item.getOrderFlag(), "标识不能为空");
                if (Objects.isNull(item.getQty()) || item.getQty() <= 0d) {
                    MesException.throwMesBusiException("生产数量不能小于等于0");
                }
                //校验产线类型和工单类型是否匹配
                if (!Objects.equals(mesWorkCenter.getCenterType(), MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue())) {
                    MesException.throwMesBusiException("产线【%s】类型为【%s】，请选择非排序产线", mesWorkCenter.getWorkCenterCode(),
                            MesExtEnumUtil.WORK_CENTER_TYPE.valueOfDescription(mesWorkCenter.getCenterType()));
                }
                if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue().equals(item.getOrderFlag()) &&
                        !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue().equals(item.getOrderFlag()) &&
                        !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(item.getOrderFlag())) {
                    MesException.throwMesBusiException(String.format("工单标识为【%s】请选择 【%s】、【%s】、【%s】 标识",
                            item.getOrderFlag(), MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue()
                            , MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue(),
                            MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue()));
                }
                //根据产线代码获取生产组信息
                MesPartProdGroup mesPartProdGroup = null;
                if (mesPartProdGroupMap.containsKey(mesWorkCenter.getWorkCenterCode())) {
                    mesPartProdGroup = mesPartProdGroupMap.get(mesWorkCenter.getWorkCenterCode());
                } else {
                    mesPartProdGroup = getMesPartProdGroup(mesWorkCenter.getOrganizeCode(), mesWorkCenter.getWorkCenterCode());
                    mesPartProdGroupMap.put(mesWorkCenter.getWorkCenterCode(), mesPartProdGroup);
                }
                if (!Objects.isNull(mesPartProdGroup)) {
                    item.setPartProdGroupCode(mesPartProdGroup.getPartProdGroupCode());
                    item.setPartProdGroupName(mesPartProdGroup.getPartProdGroupName());
                }
                //拼接时间
                packPlanTime(item, mesShiftMap);
                //状态已发布
                item.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue());
                if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(item.getOrderFlag())){
                    ValidatorBean.checkNotNull(item.getProductVersion(), "生产版本不能为空");
                    //校验物料生产版本是否存在
                    List<MesProductVersion> mesProductVersions = mesProductVersionMap.get(item.getPartNo());
                    if (CollectionUtils.isEmpty(mesProductVersions)) {
                        MesException.throwMesBusiException("物料【%s】对应的生产版本信息不存在", item.getPartNo());
                    }
                    List<MesProductVersion> versionList = mesProductVersions.stream().filter(t -> Objects.equals(item.getProductVersion(), t.getProductVersion())).collect(Collectors.toList());
                    if (CollectionUtils.isEmpty(versionList)) {
                        MesException.throwMesBusiException("物料【%s】生产版本【%s】信息不存在", item.getPartNo(), item.getProductVersion());
                    }
                    MesProductVersion mesProductVersion = versionList.iterator().next();
                    item.setErpWorkCenter(mesProductVersion.getWorkCenterCode());
                }
            } else {
                ValidatorBean.checkNotNull(item.getPlanStartTime(), "计划开始时间不能为空");
                ValidatorBean.checkNotNull(item.getPlanEndTime(), "计划结束时间不能为空");
                if (Objects.isNull(item.getQty()) || item.getQty() <= 0d) {
                    MesException.throwMesBusiException("生产数量不能小于等于0");
                }
                //自动发布
                autoPublish(mesProductVersionMap, mesPartProdGroupMap, item, mesWorkCenter);
            }
            item.setUnCompleteQty(item.getQty());
            item.setFid(UUID.randomUUID().toString());
            index++;
        }
    }

    private void autoPublish(Map<String, List<MesProductVersion>> mesProductVersionMap, Map<String, MesPartProdGroup> mesPartProdGroupMap, MesWorkOrder item, MesWorkCenter mesWorkCenter) {
        //发送工单信息给WMS
        if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(item.getOrderFlag())){
            //获取生产版本
            List<MesProductVersion> mesProductVersions = mesProductVersionMap.get(item.getPartNo());
            if (CollectionUtils.isEmpty(mesProductVersions)) {
                MesException.throwMesBusiException("物料【%s】工作中心【%s】对应的生产版本信息不存在", item.getPartNo(),
                        mesWorkCenter.getErpWorkCenter());
            }
            MesProductVersion mesProductVersion = mesProductVersions.iterator().next();
            item.setProductVersion(mesProductVersion.getProductVersion());
        }
        //是否自动发布
        isAuto(mesPartProdGroupMap, item);
    }

    private void isAuto(Map<String, MesPartProdGroup> mesPartProdGroupMap, MesWorkOrder item) {
        //校验零件生产组信息
        MesPartProdGroup mesPartProdGroup;
        if (mesPartProdGroupMap.containsKey(item.getWorkCenterCode() + item.getPartNo())) {
            mesPartProdGroup = mesPartProdGroupMap.get(item.getWorkCenterCode() + item.getPartNo());
        } else {
            mesPartProdGroup = getMesPartProdGroup(item);
            mesPartProdGroupMap.put(item.getWorkCenterCode() + item.getPartNo(), mesPartProdGroup);
        }
        item.setPartProdGroupCode(mesPartProdGroup.getPartProdGroupCode());
        item.setPartProdGroupName(mesPartProdGroup.getPartProdGroupName());
        //自动发布
        if (CommonEnumUtil.VALID == mesPartProdGroup.getIsAutoRelease()) {
            item.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue());
        } else {
            item.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.CREATE.getValue());
        }
    }

    private List<MesShift> getMesShifts(String organizeCode, String nowDate, List<String> workCenterCodeList) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(workCenterCodeList, "workCenterCode", packBean);
        DdlPreparedPack.getStringSmallerPack(nowDate, "beginDate", packBean);
        DdlPreparedPack.getStringBiggerPack(nowDate, "endDate", packBean);
        List<MesShift> mesShiftList = mesShiftRDao.findByHqlWhere(packBean);
        if (CollectionUtils.isEmpty(mesShiftList)) {
            MesException.throwMesBusiException("有效期内的班次信息不存在");
        }
        return mesShiftList;
    }

    @Override
    public void doProductReport(MesWorkOrder mesWorkOrder) {
        MesWorkOrder mesWorkOrderDb = getMesWorkOrder(mesWorkOrder.getWorkOrderNo(),mesWorkOrder.getOrganizeCode());
        mesWorkOrderDb.setDescription(mesWorkOrder.getDescription());
        //查询物料信息
        MesPart mesPart = iMesPartService.getPartByPartNo(mesWorkOrderDb.getPartNo(), mesWorkOrderDb.getOrganizeCode());
        //查询产线信息
        MesWorkCenter mesWorkCenter = getMesWorkCenter(mesWorkOrderDb.getOrganizeCode(),mesWorkOrderDb.getWorkCenterCode());
        //获取生产版本
        MesProductVersion mesProductVersion = getMesProductVersion(mesWorkOrderDb.getOrganizeCode(),mesWorkOrderDb.getPartNo(),mesWorkOrderDb.getProductVersion());
        //物料+生产版本获取bom信息
        List<MesBom> mesBoms = mesBomService.findBomList(mesPart.getOrganizeCode(), mesPart, mesProductVersion.getAlternativePartList());
        //报工类型
        if (MesExtEnumUtil.REPORT_TYPE.REPORT.getValue() == mesWorkOrder.getReportType()) {
            mesWorkOrderDb.setReportedQty(MathOperation.add(mesWorkOrder.getNum(), mesWorkOrderDb.getReportedQty()));
            //更新工单状态
            double unCompleteQty = MathOperation.sub(mesWorkOrderDb.getQty(), mesWorkOrderDb.getReportedQty());
            mesWorkOrderDb.setUnCompleteQty(unCompleteQty > 0 ? unCompleteQty : 0);
            if (mesWorkOrderDb.getReportedQty() > mesWorkOrderDb.getQty()) {
                // 以下则是超工单逻辑
                // 如果产线中没有配置超工单，则直接阻断
                if (!Objects.equals(CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue(), mesWorkCenter.getIsCheckOrderQty())) {
                    MesException.throwMesBusiException("请检查工单数量,工单号[%s],工单数量[%s]报工数量[%s],且未配置超工单!", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getQty(), mesWorkOrder.getReportedQty());
                }
                // 如果配置了超工单，且比例已经超过了配置的超工单比例，也需要阻断
                double rate =  MathOperation.div((mesWorkOrderDb.getReportedQty() - mesWorkOrderDb.getQty()),mesWorkOrderDb.getQty());
                if (rate > MathOperation.div(mesWorkCenter.getOrderRate(),100)) {
                    MesException.throwMesBusiException("请检查工单数量,工单号[%s],工单数量[%s]报工数量[%s],配置了超工单,但超过了比例[%s]!", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getQty(), mesWorkOrder.getReportedQty(), mesWorkCenter.getOrderRate());
                }
                mesWorkOrder.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.COMPLETE.getValue());
            } else if (Objects.equals(mesWorkOrderDb.getReportedQty(), mesWorkOrderDb.getQty())) {
                mesWorkOrderDb.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.COMPLETE.getValue());
            } else {
                mesWorkOrderDb.setWorkOrderStatus(mesWorkOrder.getWorkOrderStatus()==MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue()?
                        MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue():MesExtEnumUtil.ORDER_STATUS.PROCESS.getValue());
            }
            mesWorkOrderDb.setCompleteQty(mesWorkOrderDb.getReportedQty());
        } else {
            //报工调整数量加-
            mesWorkOrderDb.setAdjustQty((MathOperation.add(mesWorkOrder.getNum(), mesWorkOrderDb.getAdjustQty())));
            //冲销数量大于工单完成数量报错
            if (mesWorkOrderDb.getAdjustQty() > mesWorkOrderDb.getReportedQty()) {
                MesException.throwMesBusiException("冲销数量【%s】大于工单完成数量【%s】,不允许冲销",
                        mesWorkOrderDb.getAdjustQty(), mesWorkOrderDb.getReportedQty());
            }
        }
        mesWorkOrderDb.setRemark(mesWorkOrder.getRemark());
        //更新工单
        updateMesWorkOrder(mesWorkOrderDb,(MesExtEnumUtil.REPORT_TYPE.REPORT.getValue() == mesWorkOrder.getReportType()) ? MesExtEnumUtil.WORK_ORDER_LOG_TYPE.REPORT : MesExtEnumUtil.WORK_ORDER_LOG_TYPE.REPORT_ADJUST,mesWorkOrder.getNum());
        //试制单不报工
        if(Objects.isNull(mesWorkOrderDb.getOrderFlag()) || !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(mesWorkOrderDb.getOrderFlag())){
            String sn = getStringList(mesWorkOrder.getOrganizeCode());
            //保存数据
            List<MesProductOffLine> mesProductOffLineList = new ArrayList<>();
            String nowTime = StringUtil.isEmpty(mesWorkOrder.getDescription())?TimeTool.getNowTime(true):mesWorkOrder.getDescription();

            for (MesBom mesBom : mesBoms) {
                mesProductOffLineList.add(creatMesProductOffLine(mesWorkOrder, mesProductVersion, sn, mesBom, false,nowTime,mesBoms.size()));
            }
            mesProductOffLineService.insertBatch(mesProductOffLineList);
        }
    }

    @Override
    public void doProductReportExt(MesWorkOrder mesWorkOrderNew) {
        MesWorkOrder mesWorkOrder = getMesWorkOrder(mesWorkOrderNew.getWorkOrderNo(),mesWorkOrderNew.getOrganizeCode());
        //查询物料信息
        MesPart mesPart = iMesPartService.getPartByPartNo(mesWorkOrder.getPartNo(), mesWorkOrder.getOrganizeCode());
        if (mesWorkOrderNew.getNum() <= 0) {
            MesException.throwMesBusiException("工单报工数量不能为0,不允许报工");
        }
        //查询产线信息
        MesWorkCenter workCenter = getMesWorkCenter(mesWorkOrder.getOrganizeCode(),mesWorkOrder.getWorkCenterCode());
        //报工类型
        //报工
        if (MesExtEnumUtil.REPORT_TYPE.REPORT.getValue() == mesWorkOrderNew.getReportType()) {
            mesWorkOrder.setReportedQty(MathOperation.add(mesWorkOrderNew.getNum(), mesWorkOrder.getReportedQty()));
            //更新工单状态
            double unCompleteQty = MathOperation.sub(mesWorkOrder.getQty(), mesWorkOrder.getReportedQty());
            mesWorkOrder.setUnCompleteQty(unCompleteQty > 0 ? unCompleteQty : 0);
            if (mesWorkOrder.getReportedQty() > mesWorkOrder.getQty()) {
                // 以下则是超工单逻辑
                // 如果产线中没有配置超工单，则直接阻断
                if (!Objects.equals(CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue(), workCenter.getIsCheckOrderQty())) {
                    MesException.throwMesBusiException("请检查工单数量,工单号[%s],工单数量[%s]报工数量[%s],且未配置超工单!", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getQty(), mesWorkOrder.getReportedQty());
                }
                // 如果配置了超工单，且比例已经超过了配置的超工单比例，也需要阻断
                double rate = (mesWorkOrder.getReportedQty() - mesWorkOrder.getQty())/mesWorkOrder.getQty();
                if (rate > MathOperation.div(workCenter.getOrderRate(),100)) {
                    MesException.throwMesBusiException("请检查工单数量,工单号[%s],工单数量[%s]报工数量[%s],配置了超工单,但超过了比例[%s]!", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getQty(), mesWorkOrder.getReportedQty(), workCenter.getOrderRate());
                }
                mesWorkOrder.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.COMPLETE.getValue());
            } else if (Objects.equals(mesWorkOrder.getReportedQty(), mesWorkOrder.getQty())) {
                mesWorkOrder.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.COMPLETE.getValue());
            } else {
                mesWorkOrder.setWorkOrderStatus(mesWorkOrder.getWorkOrderStatus()==MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue()?
                        MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue():MesExtEnumUtil.ORDER_STATUS.PROCESS.getValue());
            }
            mesWorkOrder.setCompleteQty(mesWorkOrder.getReportedQty());
        } else {
            //报工调整数量加-
            mesWorkOrder.setAdjustQty((MathOperation.add(mesWorkOrderNew.getNum(), mesWorkOrder.getAdjustQty())));
            //冲销数量大于工单完成数量报错
            if (mesWorkOrder.getAdjustQty() > mesWorkOrder.getReportedQty()) {
                MesException.throwMesBusiException("冲销数量【%s】大于工单完成数量【%s】,不允许冲销",
                        mesWorkOrder.getAdjustQty(), mesWorkOrder.getReportedQty());
            }
        }
        //获取生产版本
        MesProductVersion mesProductVersion = getMesProductVersion(mesWorkOrder.getOrganizeCode(), mesWorkOrder.getPartNo(), mesWorkOrder.getProductVersion());
        //物料+生产版本获取bom信息
        List<MesBom> mesBoms = mesBomService.findBomList(mesPart.getOrganizeCode(), mesPart, mesProductVersion.getAlternativePartList());
        //生成条码
        String sn = getStringList(mesWorkOrderNew.getOrganizeCode());
        //保存数据
        List<MesProductOffLine> mesProductOffLineList = new ArrayList<>();
        List<MesMove> mesMoveList = new ArrayList<>();
        boolean isReport = false;
        boolean isMove = false;
        String nowTime = TimeTool.getNowTime(true);
        //排序工单
        if (MesExtEnumUtil.ORDER_TYPE.SORT.getValue() == mesWorkOrder.getWorkOrderType()) {
            //报工类型
            if (MesExtEnumUtil.REPORT_TYPE.WRITE_OFF.getValue() == mesWorkOrder.getReportType()) {
                MesException.throwMesBusiException("工单【%s】为排序工单不允许冲销", mesWorkOrder.getWorkOrderNo());
            }
            //排序加工规则
            MesProdRuleSortCfg mesProdRuleSortCfg = getMesProdRuleSortCfg(mesWorkOrder);
            if (MesExtEnumUtil.MES_REPORT_TYPE.REPORT.getValue() == mesProdRuleSortCfg.getReportType()) {
                isReport = true;
            } else if (MesExtEnumUtil.MES_REPORT_TYPE.MOVE.getValue() == mesProdRuleSortCfg.getReportType()) {
                isMove = true;
            } else if (MesExtEnumUtil.MES_REPORT_TYPE.REPORT_MOVE.getValue() == mesProdRuleSortCfg.getReportType()) {
                isReport = true;
                isMove = true;
            } else if (MesExtEnumUtil.MES_REPORT_TYPE.CUSTOMER_SUPPLY_MOVE.getValue() == mesProdRuleSortCfg.getReportType()) {
                customerSupplyMove(mesWorkOrderNew, mesProductVersion, mesBoms, sn, mesProductOffLineList, mesMoveList,nowTime,true);
            } else {
                log.info("工单{}排序加工规则报工类型未维护", mesWorkOrder.getWorkOrderNo());
                return;
            }

            if (MesExtEnumUtil.MES_REPORT_TYPE.CUSTOMER_SUPPLY_MOVE.getValue() != mesProdRuleSortCfg.getReportType()) {
                //查询SAP物料信息
                MesPartSap mesPartSap = mesPartSapService.getMesPartSapByPartNo(mesWorkOrder.getPartNo(), mesWorkOrder.getOrganizeCode());
                //成品汇报
                if (isReport) {
                    for (MesBom mesBom : mesBoms) {
                        mesProductOffLineList.add(creatMesProductOffLine(mesWorkOrderNew, mesProductVersion, sn, mesBom, false,nowTime,mesBoms.size()));
                    }
                }
                //成品移库
                if (isMove) {
                    MesMove move = createMove(mesPartSap, mesProdRuleSortCfg.getSrcErpLocation(), mesProdRuleSortCfg.getDestErpLocation(), mesWorkOrder.getOrganizeCode(), mesWorkOrder.getWorkCenterCode(), mesWorkOrderNew.getNum(), sn, MesExtEnumUtil.MOVE_TYPE.FINISH_PRODUCTS_MOVE.getValue());
                    move.setMatnr(mesWorkOrder.getPartNo());
                    mesMoveList.add(move);
                }
            }
        } else if (MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue() == mesWorkOrder.getWorkOrderType()) {
            MesProdRuleNosortCfg mesProdRuleNoSortCfg = mesProdRuleNosortCfgService.findMesProdRuleNosortCfgByWorkCenterCode(mesWorkOrder.getWorkCenterCode(), mesWorkOrder.getPartNo(), mesWorkOrder.getOrganizeCode());
            if (MesExtEnumUtil.NOSORT_REPORT_TYPE.REPORT.getValue() == mesProdRuleNoSortCfg.getReportType()) {
                for (MesBom mesBom : mesBoms) {
                    mesProductOffLineList.add(creatMesProductOffLine(mesWorkOrderNew, mesProductVersion, sn, mesBom, false,nowTime,mesBoms.size()));
                }
            }else if(MesExtEnumUtil.NOSORT_REPORT_TYPE.CUSTOMER_SUPPLY_MOVE.getValue() == mesProdRuleNoSortCfg.getReportType()) {
                customerSupplyMove(mesWorkOrderNew, mesProductVersion, mesBoms, sn, mesProductOffLineList, mesMoveList,nowTime,false);
            }
        } else {
            log.info("工单{}排序规则不属于排序工单和非排序工单", mesWorkOrder.getWorkOrderNo());
            return;
        }

        //更新工单
        updateMesWorkOrder(mesWorkOrder, (MesExtEnumUtil.REPORT_TYPE.REPORT.getValue() == mesWorkOrderNew.getReportType()) ? MesExtEnumUtil.WORK_ORDER_LOG_TYPE.REPORT : MesExtEnumUtil.WORK_ORDER_LOG_TYPE.REPORT_ADJUST,mesWorkOrderNew.getNum());

        //保存报工记录 试制单不报工
        if (CollectionUtils.isNotEmpty(mesProductOffLineList) && (Objects.isNull(mesWorkOrder.getOrderFlag()) || !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(mesWorkOrder.getOrderFlag()))) {
            mesProductOffLineList.forEach(t->{
                if(Objects.isNull(t.getBomTotalSize())){
                    t.setBomTotalSize(mesProductOffLineList.size());
                }
            });
            mesProductOffLineService.insertBatch(mesProductOffLineList);
        }
        //保存移库记录
        if (CollectionUtils.isNotEmpty(mesMoveList)) {
            mesMoveRDao.saveAll(mesMoveList);
        }
    }

    @Override
    public void doCloseUnSortOrder(String organizeCode,String userName) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getNumEqualPack(MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue(), "workOrderType", ddlPackBean);
        DdlPreparedPack.getStringSmallerNotEqualPack(TimeTool.getToday(), "planStartTime", ddlPackBean);
        //非排序的试制工单(P单)不自动关单（芜湖）
        if (mesConfigService.checkCfgValue(organizeCode, MesExtConstWords.CLOSE_P_WORK_ORDER, MesExtConstWords.ONE_STR)) {
            DdlPreparedPack.getStringNoEqualPack(MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue(), "orderFlag", ddlPackBean);
        }
        DdlPreparedPack.getNumberSmallerPack(MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue(), "workOrderStatus", ddlPackBean);
        List<MesWorkOrder> mesWorkOrderList = baseRDao.findByHqlWhere(ddlPackBean);
        if(CollectionUtils.isEmpty(mesWorkOrderList)){
            return;
        }
        log.info("关闭工单个数{},工单:{}",mesWorkOrderList.size(),mesWorkOrderList.stream().map(MesWorkOrder::getWorkOrderNo).collect(Collectors.toList()));
        //查询自制件零件
        List<String> partNoList = mesPartSapService.findMesPartSapByPartNoList(mesWorkOrderList.stream().map(MesWorkOrder::getPartNo).distinct().collect(Collectors.toList()), organizeCode).stream().filter(t -> t.getIsTestPiece() == CommonEnumUtil.FALSE).map(MesPartSap::getPartNo).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(partNoList)) {
            //关闭工单回传
            List<String> partNoAndDataKey = mesWorkOrderList.stream().filter(t -> !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(t.getOrderFlag()) && partNoList.contains(t.getPartNo())).map(t -> new StringJoiner(MesExtConstWords.COMMA).add(t.getPartNo()).add(t.getProductVersion()).add(t.getPlanStartTime().substring(0, 10)).toString()).distinct().collect(Collectors.toList());
            if (CollectionUtils.isNotEmpty(partNoAndDataKey)) {
                List<MesWorkOrderToSap> mesWorkOrderToSapList = new ArrayList<>();
                for (String partNoAndData : partNoAndDataKey) {
                    MesWorkOrderToSap orderToSap = new MesWorkOrderToSap(organizeCode, partNoAndData.split(MesExtConstWords.COMMA)[0], partNoAndData.split(MesExtConstWords.COMMA)[1], 0d, partNoAndData.split(MesExtConstWords.COMMA)[2]);
                    ConvertBean.serviceModelInitialize(orderToSap, userName);
                    mesWorkOrderToSapList.add(orderToSap);
                }
                mesWorkOrderToSapRepository.saveAll(mesWorkOrderToSapList);
            }
        }
        //关闭工单
        baseRDao.updateByProperties(new String[]{"modifyUser", "modifyDatetime", "workOrderStatus","systemSyncStatus"},
                new Object[]{userName, TimeTool.getNowTime(true), MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue(),CommonEnumUtil.FALSE}, ddlPackBean);
    }


    @Override
    public void doReportWorkReversal(WmsProductModel model) {
        log.info("WMS发运调用MES接口CRB负报工请求数据:{}", JSONObject.toJSONString(model));
        //查询物料信息
        MesPart mesPart = iMesPartService.getPartByPartNo(model.getPartNo(), model.getOrganizeCode());
        //保存数据
        List<MesProductOffLine> mesProductOffLineList = new ArrayList<>();
        String nowTime = TimeTool.getNowTime(true);
        if (StringUtil.isEmpty(model.getSn())) {
            //获取生产版本
            MesProductVersion mesProductVersion = getMesProductVersion(model.getOrganizeCode(),model.getPartNo());
            //获取bom
            List<MesBom> mesBoms = mesBomService.findBomList(mesPart.getOrganizeCode(), mesPart, mesProductVersion.getAlternativePartList());
            //生成流水码
            model.setSn(getStringList(model.getOrganizeCode()));
            for (MesBom mesBom : mesBoms) {
                mesProductOffLineList.add(getMesProductOffLine(model, mesPart, mesProductVersion, mesBom,nowTime,mesBoms.size()));
            }
        } else {
            //按照条码查询之前报工数据
            mesProductOffLineList.addAll(getMesProductOffLineList(model, nowTime));
        }
        mesProductOffLineRDao.saveAll(mesProductOffLineList);
    }

    @Override
    public void doReopen(Long[] ids,String userName,String organizeCode) {
        //获取工单信息
        List<MesWorkOrder> mesWorkOrderList = getMesWorkOrderList(ids, organizeCode);
        //数据更新
        for (MesWorkOrder mesWorkOrder : mesWorkOrderList) {
            if (MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue() != mesWorkOrder.getWorkOrderStatus()) {
                MesException.throwMesBusiException("工单【%S】状态不为关闭，请检查数据", mesWorkOrder.getWorkOrderNo());
            }
            if (!MesExtEnumUtil.OK_NOK.NOK.getValue().equals(mesWorkOrder.getCcscStatus())) {
                MesException.throwMesBusiException("工单【%S】CCSC状态不为NOK，请检查数据", mesWorkOrder.getWorkOrderNo());
            }
            if (mesWorkOrder.getUnCompleteQty() <= 0) {
                MesException.throwMesBusiException("工单【%s】未完成数量小于等于0，请检查数据", mesWorkOrder.getWorkOrderNo());
            }
            //更新工单状态
            mesWorkOrder.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.PROCESS.getValue());
            mesWorkOrder.setCcscStatus("");
            updateMesWorkOrder(mesWorkOrder,MesExtEnumUtil.WORK_ORDER_LOG_TYPE.UPDATE,mesWorkOrder.getQty());
        }
        //重新生成CCSC task
        mesCcscTaskService.insertMesCcscTask(organizeCode,mesWorkOrderList);
    }

    @Override
    public void doSaveWorkOrderPrintQueue(MesWorkOrder workOrder) {
        if (workOrder == null) return;

        if (workOrder.getWorkOrderType() != MesExtEnumUtil.ORDER_TYPE.SORT.getValue()) {
            log.info("doSaveWorkOrderPrintQueue --- 工单:{} 为非排序,无需新增打印队列", workOrder.getWorkOrderNo());
            return;
        }

        if (workOrder.getWorkOrderStatus() != MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue()) {
            log.info("doSaveWorkOrderPrintQueue --- 工单:{} 不为{},无需新增打印队列", workOrder.getWorkOrderNo(), MesExtEnumUtil.ORDER_STATUS.RELEASE.getDescription());
            return;
        }

        insertPrintQueue(workOrder);

    }

    @Override
    public List<Map<String, Object>> doReprintWorkOrder(Long[] ids, String organizeCode, String userName) {

        // 根据id 获取工单数据
        List<MesWorkOrder> mesWorkOrderList = getMesWorkOrderList(ids, organizeCode);

        return packPrintResultMap(organizeCode, mesWorkOrderList, userName,false);

    }

    private List<Map<String, Object>> packPrintResultMap(String organizeCode, List<MesWorkOrder> mesWorkOrderList, String userName,Boolean isShow) {
        // 根据工单号对工单分组
        Map<String, MesWorkOrder> workOrderMapByWorkOrderNo = mesWorkOrderList.stream().collect(Collectors.toMap(MesWorkOrder::getWorkOrderNo, Function.identity(), (x, y) -> y));

        // 产线代码集合
        List<String> workCenterCodeList = mesWorkOrderList.stream().map(MesWorkOrder::getWorkCenterCode).distinct().collect(Collectors.toList());

        // 根据产线代码节后获取产线信息集合
        List<MesWorkCenter> mesWorkCenters = workCenterService.queryMesWorkCenterList(workCenterCodeList, organizeCode);

        // 产线名称集合
        Map<String, String> workCenterNameMap = CollectionUtils.isEmpty(mesWorkCenters) ? null : mesWorkCenters.stream().collect(Collectors.toMap(MesWorkCenter::getWorkCenterCode, MesWorkCenter::getWorkCenterName, (x, y) -> y));

        // 生产零件号
        List<String> partProdGroupCodeList =  mesWorkOrderList.stream().map(MesWorkOrder::getPartProdGroupCode).distinct().collect(Collectors.toList());

        // 根据零件生产组代码分组
        Map<String, MesPartProdGroup> partProdGroupMap = partProdGroupService.getMesPartProdGroupMap(organizeCode, partProdGroupCodeList);

        // 客户车型配置名称MAP
        Map<String, MesCustomerCarModel> carModelMapByCode = getMesCustomerCarModelMap(organizeCode, mesWorkOrderList);

        // 工单装配件
        Map<String, List<MesWorkOrderAssembly>> workOrderAssemblyMapByWorkOrderNo = getWorkOrderAssemblyMapByWorkOrderNo(organizeCode, workOrderMapByWorkOrderNo);

        // 返回结果
        List<Map<String, Object>> resultMapList = new ArrayList<>();

        // 条码打印
        List<MesPrintedSnLog> printedSnLogList = new ArrayList<>();

        for (MesWorkOrder mesWorkOrder : mesWorkOrderList) {

            if (mesWorkOrder == null) {
                log.info("doReprintWorkOrder --- 工单为空 暂不输出打印");
                continue;
            }

            mesWorkOrder.setWorkCenterName(!Objects.isNull(workCenterNameMap) && workCenterNameMap.containsKey(mesWorkOrder.getWorkCenterCode()) ? workCenterNameMap.get(mesWorkOrder.getWorkCenterCode()) : "");

            MesPartProdGroup mesPartProdGroup = !Objects.isNull(partProdGroupMap) && partProdGroupMap.containsKey(mesWorkOrder.getPartProdGroupCode()) ? partProdGroupMap.get(mesWorkOrder.getPartProdGroupCode()) : null;

            if (mesPartProdGroup == null) {
                MesException.throwMesBusiException("工单【%s】关联零件生产组【%s】不存在", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getPartProdGroupCode());
            }

            String printTemplate = mesPartProdGroup.getPrintTemplate();

            if (StringUtils.isEmpty(printTemplate)) {
                MesException.throwMesBusiException("工单【%s】关联零件生产组【%s】打印模板为空", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getPartProdGroupCode());
            }

            MesLabelTemplate labelTemplate = labelTemplateService.getLabelTemplate(isShow ? printTemplate + "_SHOW" : printTemplate, organizeCode);
            //模板信息丢失抛出异常
            if (Objects.isNull(labelTemplate) || StringUtils.isEmpty(labelTemplate.getMethodCode())) {
                MesException.throwMesBusiException("工单【%s】关联零件生产组【%s】打印模板【%s】为空", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getPartProdGroupCode(), labelTemplate.getTemplateCode());
            }
            //根据反射获取策略类--封装打印数据
            String methodCode = labelTemplate.getMethodCode();
            Map<String, Object> modelMap = new HashMap<>();
            modelMap.put("mesWorkOrder", mesWorkOrder);
            modelMap.put("mesPartProdGroup", mesPartProdGroup);

            MesCustomerCarModel customerCarModel = !Objects.isNull(carModelMapByCode) && carModelMapByCode.containsKey(mesWorkOrder.getCarModelCode()) ? carModelMapByCode.get(mesWorkOrder.getCarModelCode()) : null;
            if (customerCarModel != null) {
                modelMap.put("mesCustomerCarModel", customerCarModel);
            }
            List<MesWorkOrderAssembly> workOrderAssemblyListByWorkOrderNo = !Objects.isNull(workOrderAssemblyMapByWorkOrderNo) && workOrderAssemblyMapByWorkOrderNo.containsKey(mesWorkOrder.getWorkOrderNo()) ? workOrderAssemblyMapByWorkOrderNo.get(mesWorkOrder.getWorkOrderNo()) : null;

            if (!CollectionUtils.isEmpty(workOrderAssemblyListByWorkOrderNo)) {
                modelMap.put("mesWorkOrderAssemblyList", workOrderAssemblyListByWorkOrderNo);
            }

            MesProduceSnPrintModel mesProduceSnPrintModel = new MesProduceSnPrintModel();
            mesProduceSnPrintModel.setMesLabelTemplate(labelTemplate);
            mesProduceSnPrintModel.setSourceData(modelMap);
            mesProduceSnPrintModel.setPrinter(mesPartProdGroup.getPrinter());

            MesProduceSnPrintModel snPrintModel = null;
            try {
                IPrintTemplateStrategyService strategyService = (IPrintTemplateStrategyService) SpringContextsUtil.getBean(methodCode);
                snPrintModel = strategyService.execute(null, mesProduceSnPrintModel, null);
            } catch (BeansException e) {
                MesException.throwMesBusiException("工单【%s】关联零件生产组【%s】打印模板【%s】策略类【%s】执行异常", mesWorkOrder.getWorkOrderNo(), mesWorkOrder.getPartProdGroupCode(), labelTemplate.getTemplateCode(), labelTemplate.getMethodCode());
            }

            MesPrintedSnLog printedSnLog = new MesPrintedSnLog();
            printedSnLog.setOrganizeCode(mesWorkOrder.getOrganizeCode());
            printedSnLog.setWorkOrderNo(mesWorkOrder.getWorkOrderNo());
            printedSnLog.setCustPartNo(mesWorkOrder.getCustPartNo());
            ConvertBean.serviceModelInitialize(printedSnLog, userName);
            printedSnLogList.add(printedSnLog);

            resultMapList.addAll(snPrintModel.getPrintContextList());

        }

        if (!CollectionUtils.isEmpty(printedSnLogList)) printedSnLogRepository.saveAll(printedSnLogList);

        return resultMapList;
    }

    @Override
    public List<Map<String, Object>> doShowWorkOrderPrint(String partNo, String workCenterCode, String partProdGroupCode,
                                                          String carModelCode, String organizeCode, String userName) {

        DdlPackBean packBean =  DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(partNo, MesExtConstWords.PART_NO, packBean);
        DdlPreparedPack.getStringEqualPack(workCenterCode, MesExtConstWords.WORK_CENTER_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(partProdGroupCode, MesExtConstWords.PART_PROD_GROUP_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(carModelCode, MesExtConstWords.CAR_MODEL_CODE, packBean);
        packBean.setOrderByStr(" order by createDatetime desc ");
        MesWorkOrder workOrder = workOrderRepository.getByProperty(packBean);
        if (Objects.isNull(workOrder)) {
            MesException.throwMesBusiException("零件【%s】产线【%s】生产组【%s】车型【%s】的工单不存在", partNo, workCenterCode, partProdGroupCode, carModelCode);
        }

        List<MesWorkOrder> workOrderList = new ArrayList<>();
        workOrderList.add(workOrder);

        return packPrintResultMap(organizeCode, workOrderList, userName,true);
    }

    private Map<String, MesCustomerCarModel> getMesCustomerCarModelMap(String organizeCode, List<MesWorkOrder> workOrderList) {
        List<String> carModelCodeList = workOrderList.stream().map(MesWorkOrder::getCarModelCode).distinct().collect(Collectors.toList());
        // 客户车型配置
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(carModelCodeList, MesExtConstWords.CAR_MODEL_CODE, packBean);
        List<MesCustomerCarModel> customerCarModelList = customerCarModelRepository.findByHqlWhere(packBean);

        return CollectionUtils.isEmpty(customerCarModelList) ? null : customerCarModelList.stream().collect(Collectors.toMap(MesCustomerCarModel::getCarModelCode, Function.identity(), (x, y) -> y));
    }

    private Map<String, List<MesWorkOrderAssembly>> getWorkOrderAssemblyMapByWorkOrderNo(String organizeCode, Map<String, MesWorkOrder> workOrderMapByWorkOrderNo) {
        List<String> workOrderNoList = workOrderMapByWorkOrderNo.keySet().stream().collect(Collectors.toList());
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(workOrderNoList, MesExtConstWords.WORK_ORDER_NO, packBean);
        List<MesWorkOrderAssembly> workOrderAssemblyList = workOrderAssemblyRepository.findByHqlWhere(packBean);
        return CollectionUtils.isEmpty(workOrderAssemblyList) ? null : workOrderAssemblyList.stream().collect(Collectors.groupingBy(MesWorkOrderAssembly::getWorkOrderNo));
    }

    private List<MesProductOffLine> getMesProductOffLineList(WmsProductModel model, String nowTime) {
        //查询报工数据
        List<MesProductOffLine> oldProductOffLineList = mesProductOffLineService.findMesProductOffLineByProductSn(model.getSn(), model.getOrganizeCode());
        if (CollectionUtils.isEmpty(oldProductOffLineList)) {
            MesException.throwMesBusiException("条码【%s】未查询到报工数据", model.getSn());
        }
        //oldProductOffLineList = mesProductOffLineService.findMesProductOffLineByRecordId(oldProductOffLineList.iterator().next().getProductionRecordId(), model.getOrganizeCode());
        List<MesProductOffLine> newProductOffLineList = new ArrayList<>(oldProductOffLineList.size());
        oldProductOffLineList.forEach(item -> {
            MesProductOffLine mesProductOffLine = new MesProductOffLine();
            BeanUtils.copyProperties(item, mesProductOffLine, MesExtConstWords.ID);
            mesProductOffLine.setReportType(MesExtEnumUtil.REPORT_TYPE.CBR.getValue());
            mesProductOffLine.setOrderNo(model.getShipOrderNo());
            mesProductOffLine.setCustNo(model.getCustNo());
            mesProductOffLine.setCustOrder(model.getCustOrderNo());
            mesProductOffLine.setDescription(nowTime);
            mesProductOffLine.setStgeLoc(item.getAlort());
            mesProductOffLine.setSystemSyncStatus(CommonEnumUtil.FALSE);
            mesProductOffLine.setSystemSyncDatetime("");
            ConvertBean.serviceModelInitialize(mesProductOffLine, model.getUserName());
            newProductOffLineList.add(mesProductOffLine);
        });
        return newProductOffLineList;
    }

    private List<MesWorkOrder> getMesWorkOrderList(Long[] ids, String organizeCode) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackArray(ids,MesExtConstWords.ID,packBean);
        List<MesWorkOrder> mesWorkOrderList = baseRDao.findByHqlWhere(packBean);
        if (CollectionUtils.isEmpty(mesWorkOrderList)) {
            MesException.throwMesBusiException("选择工单信息不存在");
        }
        return mesWorkOrderList;
    }

    public MesWorkOrder getMesWorkOrder(String workOrderNo, String organizeCode) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo,"workOrderNo",packBean);
        MesWorkOrder mesWorkOrder = baseRDao.getByProperty(packBean);
        if (Objects.isNull(mesWorkOrder)) {
            MesException.throwMesBusiException("工单【%s】信息不存在", workOrderNo);
        }
        return mesWorkOrder;
    }

    private void updateMesWorkOrder(MesWorkOrder mesWorkOrder,MesExtEnumUtil.WORK_ORDER_LOG_TYPE type,double qty) {
        //修改工单，需要重新同步
        mesWorkOrder.setSystemSyncStatus(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
        ConvertBean.serviceModelUpdate(mesWorkOrder, AuthUtil.getSessionUser().getUserName());
        baseRDao.update(mesWorkOrder);
        //保存记录
        workOrderLogService.saveMesWorkOrderLog(mesWorkOrder,type,qty);
    }

    private MesProductOffLine getMesProductOffLine(WmsProductModel model, MesPart mesPart, MesProductVersion mesProductVersion, MesBom mesBom,String nowTime,Integer bomTotalSize) {
        MesProductOffLine newMesProductOffLine = new MesProductOffLine();
        newMesProductOffLine.setReportPartNo(mesPart.getPartNo());
        newMesProductOffLine.setReportPartNameRdd(mesPart.getPartName());
        newMesProductOffLine.setReportSn(model.getSn());
        newMesProductOffLine.setItemPartNo(mesBom.getItemPartNo());
        newMesProductOffLine.setItemPartName(mesBom.getItemPartName());
        newMesProductOffLine.setItemQty(MathOperation.mul(model.getQty(), mesBom.getItemQty()));
        newMesProductOffLine.setWorkCenterCode(mesProductVersion.getWorkCenterCode());
        newMesProductOffLine.setSapWorkCenter(mesProductVersion.getWorkCenterCode());
        newMesProductOffLine.setAlort(mesProductVersion.getReceiveInventoryPoint());
        newMesProductOffLine.setStgeLoc(mesProductVersion.getReceiveInventoryPoint());
        newMesProductOffLine.setQty(model.getQty());
        newMesProductOffLine.setBomVersion(mesProductVersion.getProductVersion());
        newMesProductOffLine.setSerialNumber(model.getSn());
        newMesProductOffLine.setUnit(mesBom.getUnit());
        newMesProductOffLine.setItemUnit(mesBom.getItemUnit());
        newMesProductOffLine.setReportType(MesExtEnumUtil.REPORT_TYPE.CBR.getValue());
        newMesProductOffLine.setOrganizeCode(model.getOrganizeCode());
        newMesProductOffLine.setOrderNo(model.getShipOrderNo());
        newMesProductOffLine.setCustNo(model.getCustNo());
        newMesProductOffLine.setCustOrder(model.getCustOrderNo());
        newMesProductOffLine.setDescription(nowTime);
        newMesProductOffLine.setBomTotalSize(bomTotalSize);

        ConvertBean.serviceModelInitialize(newMesProductOffLine, model.getUserName());
        return newMesProductOffLine;
    }

    private void customerSupplyMove(MesWorkOrder mesWorkOrder, MesProductVersion mesProductVersion, List<MesBom> mesBoms, String sn, List<MesProductOffLine> mesProductOffLineList, List<MesMove> mesMoveList,String nowTime,boolean isSort) {
        boolean isItemMove;
        boolean isItemReport;
        MesMoveRule moveRule;
        MesPart itemPart;
        //查询零件生产组的移库规则
        List<MesMoveRule> moveRules = mesMoveRuleService.findMesMoveRuleByPartProdGroupCode(mesWorkOrder.getPartProdGroupCode(), mesWorkOrder.getOrganizeCode());
        Map<String, List<MesMoveRule>> mesMoveRuleMap = moveRules.stream().filter(t -> Objects.nonNull(t.getSrcType())).collect(Collectors.groupingBy(MesMoveRule::getSrcType));
        List<String> itemPartNoList = mesBoms.stream().map(MesBom::getItemPartNo).collect(Collectors.toList());
        //子物料SAP下发信息
        Map<String, List<MesPartSap>> mesPartSapMap = getPartSapMap(mesWorkOrder, itemPartNoList);
        //获取物料信息
        Map<String, List<MesPart>> itemPartMap = getItemPartMap(mesWorkOrder, itemPartNoList);
        for (MesBom mesBom : mesBoms) {
            isItemReport = false;
            isItemMove = false;
            moveRule = null;
            itemPart = null;
            if (itemPartMap.containsKey(mesBom.getItemPartNo())) {
                itemPart = itemPartMap.get(mesBom.getItemPartNo()).iterator().next();
                if (!StringUtil.isEmpty(itemPart.getEsd()) && mesMoveRuleMap.containsKey(itemPart.getEsd())) {
                    moveRule = mesMoveRuleMap.get(itemPart.getEsd()).iterator().next();
                    if (MesExtEnumUtil.MOVE_TYPE_REPORT_TYPE.REPORT_MOVE.getValue() == moveRule.getReportType()) {
                        isItemMove = true;
                        isItemReport = true;
                    } else if (MesExtEnumUtil.MOVE_TYPE_REPORT_TYPE.REPORT.getValue() == moveRule.getReportType()) {
                        isItemReport = true;
                    } else if (MesExtEnumUtil.MOVE_TYPE_REPORT_TYPE.MOVE.getValue() == moveRule.getReportType()) {
                        isItemMove = true;
                    }
                }
            }
            //汇报
            if (isItemReport && isSort) {
                mesProductOffLineList.add(creatMesProductOffLine(mesWorkOrder, mesProductVersion, sn, mesBom, true, nowTime, null));
            } else if (isItemReport) {
                String reportSn = String.valueOf(snowflakeIdMaker.nextId());
                MesProductVersion itemVersion = getMesProductVersion(mesWorkOrder.getOrganizeCode(), mesBom.getItemPartNo(), mesProductVersion.getProductVersion());
                List<MesBom> bomList = null;
                try {
                    bomList = findBomList(mesWorkOrder.getOrganizeCode(), itemPart, itemVersion.getAlternativePartList());
                } catch (Exception e) {
                }
                //bom下的子节汇报
                if (!CollectionUtils.isEmpty(bomList)) {
                    for (MesBom bom : bomList) {
                        mesProductOffLineList.add(getMesProductOffLine(mesWorkOrder, itemVersion, reportSn, bom, mesBom.getItemQty(), true,bomList.size(), nowTime));
                    }
                } else {
                    mesProductOffLineList.add(getMesProductOffLine(mesWorkOrder, itemVersion, reportSn, mesBom, mesBom.getQty(), true,MesExtConstWords.ONE, nowTime));
                }
            }
            //移库
            if (isItemMove) {
                MesPartSap mesPartSap = null;
                if (mesPartSapMap.containsKey(mesBom.getItemPartNo())) {
                    mesPartSap = mesPartSapMap.get(mesBom.getItemPartNo()).iterator().next();
                }
                MesMove move = createMove(mesPartSap, moveRule.getErpSrcLocateNo(), moveRule.getErpDestLocateNo(), mesBom.getOrganizeCode(), mesWorkOrder.getWorkCenterCode(), mesBom.getItemQty(), "", MesExtEnumUtil.MOVE_TYPE.RAW_MATERIAL_MOVE.getValue());
                move.setMatnr(mesBom.getItemPartNo());
                mesMoveList.add(move);
            }
        }

        //bom下的子节汇报，总成也需要汇报
        if (!isSort && !CollectionUtils.isEmpty(mesProductOffLineList)) {
            for (MesBom mesBom : mesBoms) {
                mesProductOffLineList.add(getMesProductOffLine(mesWorkOrder, mesProductVersion, sn, mesBom, mesBom.getQty(), false,mesBoms.size(), nowTime));
            }
        }
    }

    private Map<String, List<MesPartSap>> getPartSapMap(MesWorkOrder mesWorkOrder, List<String> itemPartNoList) {
        List<MesPartSap> mesPartSapList = mesPartSapService.findMesPartSapByPartNoList(itemPartNoList, mesWorkOrder.getOrganizeCode());
        return mesPartSapList.stream().filter(t -> Objects.nonNull(t.getPartNo())).collect(Collectors.groupingBy(MesPartSap::getPartNo));
    }

    private Map<String, List<MesPart>> getItemPartMap(MesWorkOrder mesWorkOrder, List<String> itemPartNoList) {
        List<MesPart> itemPartList = iMesPartService.findMesPartByPartNoList(itemPartNoList, mesWorkOrder.getOrganizeCode());
        return itemPartList.stream().filter(t -> Objects.nonNull(t.getPartNo())).collect(Collectors.groupingBy(MesPart::getPartNo));
    }

    private MesProdRuleSortCfg getMesProdRuleSortCfg(MesWorkOrder mesWorkOrder) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(mesWorkOrder.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(mesWorkOrder.getPartNo(), "reportPartNo", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(mesWorkOrder.getWorkCenterCode(), "workCenterCode", ddlPackBean);
        MesProdRuleSortCfg mesProdRuleSortCfg = mesProdRuleSortCfgRDao.getByProperty(ddlPackBean);
        if (Objects.isNull(mesProdRuleSortCfg)) {
            MesException.throwMesBusiException("产线【%s】物料【%s】排序加工规则未维护", mesWorkOrder.getWorkCenterCode(), mesWorkOrder.getPartNo());
        }
        return mesProdRuleSortCfg;
    }

    private String getStringList(String organizeCode) {
        List<String> resultList = syncFuncService.syncSerialNo(new GenSerialNoModel(MesCommonConstant.REPORT_SN).organizeCode(organizeCode), AuthUtilExt.getUserName(), organizeCode, 1).getResultList();
        return resultList.iterator().next();
    }

    private MesProductOffLine getMesProductOffLine(MesWorkOrder mesWorkOrder, MesProductVersion mesProductVersion,
                                                   String sn, MesBom mesBom,Double itemQty, boolean isItemReport,Integer bomSize,String nowTime) {
        MesProductOffLine newMesProductOffLine = new MesProductOffLine();
        BeanUtils.copyProperties(mesBom, newMesProductOffLine,MesExtConstWords.ID,MesExtConstWords.SYSTEM_SYNC_STATUS);
        newMesProductOffLine.setReportPartNo(mesBom.getPartNo());
        newMesProductOffLine.setReportPartNameRdd(mesBom.getPartName());
        newMesProductOffLine.setAlort(mesProductVersion.getReceiveInventoryPoint());
        newMesProductOffLine.setStgeLoc(mesProductVersion.getShipInventoryPoint());
        newMesProductOffLine.setQty(MathOperation.mul(mesWorkOrder.getNum(),itemQty));
        newMesProductOffLine.setItemQty(MathOperation.mul(newMesProductOffLine.getQty(), mesBom.getItemQty()));
        if (isItemReport && mesBom.getPartNo().equals(mesWorkOrder.getPartNo())) {
            newMesProductOffLine.setReportPartNo(mesBom.getItemPartNo());
            newMesProductOffLine.setReportPartNameRdd(mesBom.getItemPartName());
            newMesProductOffLine.setItemPartNo("");
            newMesProductOffLine.setItemPartName("");
            newMesProductOffLine.setItemUnit("");
            newMesProductOffLine.setItemQty(0d);
        }
        newMesProductOffLine.setReportSn(sn);
        newMesProductOffLine.setSerialNumber(sn);
        newMesProductOffLine.setBomVersion(mesWorkOrder.getProductVersion());
        newMesProductOffLine.setUnit(mesBom.getUnit());
        newMesProductOffLine.setBomCode(mesBom.getBomCode());
        newMesProductOffLine.setWorkOrderNo(mesWorkOrder.getWorkOrderNo());
        newMesProductOffLine.setWorkOrderType(mesWorkOrder.getWorkOrderType());
        newMesProductOffLine.setWorkCenterCode(mesWorkOrder.getWorkCenterCode());
        newMesProductOffLine.setWorkCellCode(mesWorkOrder.getWorkCellCode());
        newMesProductOffLine.setReportType(mesWorkOrder.getReportType());
        newMesProductOffLine.setSapWorkCenter(mesProductVersion.getWorkCenterCode());
        newMesProductOffLine.setOrganizeCode(mesWorkOrder.getOrganizeCode());
        newMesProductOffLine.setDescription(nowTime);
        newMesProductOffLine.setBomTotalSize(bomSize);
        newMesProductOffLine.setProductionRecordId(mesWorkOrder.getId().toString());
        ConvertBean.serviceModelInitialize(newMesProductOffLine, mesWorkOrder.getModifyUser());
        return newMesProductOffLine;
    }


    private MesProductOffLine creatMesProductOffLine(MesWorkOrder mesWorkOrder, MesProductVersion mesProductVersion,
                                                     String sn, MesBom mesBom, boolean isItemReport,String nowTime,Integer bomTotalSize) {
        MesProductOffLine newMesProductOffLine = new MesProductOffLine();
        if (!isItemReport) {
            newMesProductOffLine.setReportPartNo(mesWorkOrder.getPartNo());
            newMesProductOffLine.setReportPartNameRdd(mesWorkOrder.getPartName());
        }

        newMesProductOffLine.setReportSn(sn);
        newMesProductOffLine.setItemPartNo(mesBom.getItemPartNo());
        newMesProductOffLine.setItemPartName(mesBom.getItemPartName());
        newMesProductOffLine.setItemQty(MathOperation.mul(mesWorkOrder.getNum(), mesBom.getItemQty()));
        newMesProductOffLine.setAlort(mesProductVersion.getReceiveInventoryPoint());
        newMesProductOffLine.setStgeLoc(mesProductVersion.getShipInventoryPoint());
        newMesProductOffLine.setQty(Double.valueOf(mesWorkOrder.getNum()));
        newMesProductOffLine.setBomVersion(mesWorkOrder.getProductVersion());
        newMesProductOffLine.setSerialNumber(sn);
        newMesProductOffLine.setUnit(mesBom.getUnit());
        newMesProductOffLine.setItemUnit(mesBom.getItemUnit());
        newMesProductOffLine.setWorkOrderNo(mesWorkOrder.getWorkOrderNo());
        newMesProductOffLine.setWorkOrderType(mesWorkOrder.getWorkOrderType());
        newMesProductOffLine.setWorkCenterCode(mesWorkOrder.getWorkCenterCode());
        newMesProductOffLine.setWorkCellCode(mesWorkOrder.getWorkCellCode());
        newMesProductOffLine.setReportType(mesWorkOrder.getReportType());
        newMesProductOffLine.setSapWorkCenter(mesWorkOrder.getErpWorkCenter());
        newMesProductOffLine.setOrganizeCode(mesWorkOrder.getOrganizeCode());
        newMesProductOffLine.setDescription(nowTime);
        newMesProductOffLine.setBomCode(mesBom.getBomCode());
        newMesProductOffLine.setBomTotalSize(bomTotalSize);

        ConvertBean.serviceModelInitialize(newMesProductOffLine, mesWorkOrder.getCreateUser());
        return newMesProductOffLine;
    }


    private MesWorkCenter getMesWorkCenter(String organizeCode,String workCenterCode) {
        MesWorkCenter mesWorkCenter = workCenterService.getWorkCenterDb(organizeCode, workCenterCode);
        if (Objects.isNull(mesWorkCenter)) {
            MesException.throwMesBusiException("产线【%s】不存在", workCenterCode);
        }
        return mesWorkCenter;
    }

    @Override
    public List<MesWorkOrderModel> sumMesWorkOrderQtyToSap(String organizeCode) {
        //查询汇总工单数量
        return mesWorkOrderDao.sumMesWorkOrderQtyToSap(organizeCode);
    }

    @Override
    public List<MesWorkOrder> queryMesWorkOrderProcessToSap(String organizeCode) {
        List<Integer> statusList = new ArrayList<>();
        statusList.add(MesExtEnumUtil.ORDER_STATUS.PROCESS.getValue());
//        statusList.add(MesExtEnumUtil.ORDER_STATUS.CLOSE.getValue());
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);

        DdlPreparedPack.getInPackList(statusList, "workOrderStatus", packBean);
        return baseRDao.findByHqlWhere(packBean);
    }

    private MesMove createMove(MesPartSap mesPart, String source, String target, String org, String workCenterCode, double qty, String sn, Integer moveType) {
        MesMove move = new MesMove();
        if (!Objects.isNull(mesPart)) {
            move.setMeins(mesPart.getUnit());
        }
        move.setOrganizeCode(org);
        move.setFactoryCode(org);
        move.setLgort(source);
        move.setUmlgo(target);
        move.setMenge(qty);
        move.setPostDate(TimeTool.getToday());
        move.setProductSn(sn);
        move.setMoveType(moveType);
        move.setPostTime(TimeTool.getTimeShortWithColon());
        move.setWorkCenter(workCenterService.getErpWorkCenterCode(org, workCenterCode));
        ConvertBean.serviceModelInitialize(move, AuthUtil.getSessionUser().getUserName());
        return move;
    }
    @Override
    public List<MesProductionRecord> getPreDayReportMesProductionRecord(String organizeCode,List<MesShift> mesShiftList, String  workCenterCode ) {

        //1.获取生产加工记录production_record表中，report_status为待汇报状态的工单
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workCenterCode,"workCenterCode",ddlPackBean);
        DdlPreparedPack.getNumEqualPack( MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_10.getValue(),"reportStatus",ddlPackBean);
        //获取前一天的早班到当天早班的区间的所有加工记录，统计个数
        DdlPreparedPack.timeBuilder(
                new SimpleDateFormat("yyyy-MM-dd").format(TimeTool.getDateBefore(new Date(),1))+" 08:00:00",
                TimeTool.getToday()+" 08:00:00",
                "completeDateTime", ddlPackBean, true);

        return  productionRecordRao.findByHqlWhere(ddlPackBean);
    }
    @Override
    public List<MesProduceSn> getPreDayReportMesProduceSn(String organizeCode,List<MesProductionRecord> mesProductionRecordList ) {
        DdlPackBean snPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(mesProductionRecordList.stream().map(MesProductionRecord::getProductSn).collect(Collectors.toList()),
                "productSn",snPackBean);
        return mesProduceSnRao.findByHqlWhere(snPackBean);
    }
    @Override
    public List<MesWorkOrder> insertMesWorkOrder(List<MesProductionRecord> mesProductionRecordList,List<MesShift> mesShiftList, String organizeCode, String userName) {
        List<MesWorkOrder> mesWorkOrderList=new ArrayList<>();
        Map<String, List<MesProductionRecord>> mesProductionRecordListMap = mesProductionRecordList.stream().collect(Collectors.groupingBy(sn -> sn.getWorkCenterCode() +"="+ sn.getPartNo()));
        for (Map.Entry<String, List<MesProductionRecord>> stringListEntry : mesProductionRecordListMap.entrySet()) {
            List<MesProductionRecord> value = stringListEntry.getValue();
            MesProductionRecord mesProductionRecord = value.get(0);
            String[] split = stringListEntry.getKey().split("=");
            String workCenterCode = split[0];
            String partNo = split[1];
            //查询工作中心
            DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
            DdlPreparedPack.getStringEqualPack(workCenterCode, "workCenterCode", ddlPackBean);
            MesWorkCenter mesWorkCenter = mesWorkCenterRDao.getByProperty(ddlPackBean);
            if (Objects.isNull(mesWorkCenter)) {
                MesException.throwMesBusiException("产线【%s】不存在",workCenterCode);
            }
            MesWorkOrder item=new MesWorkOrder();
            item.setOrganizeCode(organizeCode);
            item.setWorkCenterCode(workCenterCode);
            item.setErpWorkCenter(mesWorkCenter.getErpWorkCenter());
            item.setPartNo(partNo);
            item.setWorkOrderType(MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue());
            item.setOrderFlag(MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue());
            List<MesShift> collect = mesShiftList.stream().filter(s -> s.getShiftCode().equalsIgnoreCase("1")).collect(Collectors.toList());
            MesShift mesShift= collect.get(0);
            item.setShiftCode(mesShift.getShiftCode());
            item.setShiftCode(mesShift.getShiftName());
            String today = TimeTool.getToday();
            item.setPlanStartTime(today+" "+mesShift.getStartTime()+":00");
            item.setPlanEndTime(today+" "+mesShift.getEndTime()+":00");

            //生成工单号
            List<String> orderList=new ArrayList<>();
            GenSerialNoModel genSerialNoModel = new GenSerialNoModel("MES_WORK_CENTER_ORDER_NO");
            genSerialNoModel.setPartNo(workCenterCode);
            orderList = syncFuncService.syncSerialNo(genSerialNoModel.organizeCode(organizeCode), userName, organizeCode, 1).getResultList();

            String orderNo = orderList.get(0);
            DdlPackBean orderPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
            DdlPreparedPack.getStringEqualPack(orderNo, "workOrderNo", orderPackBean);
            if (baseRDao.isExitByHql(orderPackBean)) {
                MesException.throwMesBusiException("单号流水码生成重复");
            }
            item.setWorkOrderNo(orderNo);
            item.setPartName(mesProductionRecord.getPartName());
            //生产时间新增取当天
            item.setProduceTime(TimeTool.getToday());
            item.setProductTime(item.getProduceTime());
            item.setUnCompleteQty(0d);
            item.setQty(value.stream().mapToDouble(MesProductionRecord::getQty).sum());
            item.setReportedQty(item.getQty());
            item.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.COMPLETE.getValue());


            //校验标识
            //若工单类型为排序
            if (item.getWorkOrderType() == MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue()) {
                //校验产线类型和工单类型是否匹配
                if (!Objects.equals(mesWorkCenter.getCenterType(), MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue())) {
                    MesException.throwMesBusiException("产线【%s】类型为【%s】，请选择非排序产线", mesWorkCenter.getWorkCenterCode(),
                            MesExtEnumUtil.WORK_CENTER_TYPE.valueOfDescription(mesWorkCenter.getCenterType()));
                }

                //校验物料生产版本是否存在
                MesProductVersion mesProductVersion = getMesProductVersion(item.getOrganizeCode(), item.getPartNo(), item.getProductVersion());
                item.setProductVersion(mesProductVersion.getProductVersion());
            }

            item.setSystemSyncStatus(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
            item.setFid(UUID.randomUUID().toString());
            ConvertBean.serviceModelInitialize(item, userName);
            MesWorkOrder mesWorkOrder = workOrderRepository.insert(item);

            saveMesWorkOrderLog(mesWorkOrder);
            mesWorkOrderList.add(mesWorkOrder);
        }

        return mesWorkOrderList;
    }

    private void insertSortWorkOrderNo(MesWorkOrder bean, MesWorkCenter mesWorkCenter) {
        ValidatorBean.checkNotNull(bean.getOrderFlag(), "标识不能为空");
        ValidatorBean.checkNotNull(bean.getCustPartNo(), "客户物料号不能为空");

        //校验产线类型和工单类型是否匹配
        if (!Objects.equals(mesWorkCenter.getCenterType(), MesExtEnumUtil.ORDER_TYPE.SORT.getValue())) {
            MesException.throwMesBusiException("产线【%s】类型为【%s】，请选择排序产线", mesWorkCenter.getWorkCenterCode(),
                    MesExtEnumUtil.WORK_CENTER_TYPE.valueOfDescription(mesWorkCenter.getCenterType()));
        }
        //若工单类型为排序 标识为 N E P S
        if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue().equals(bean.getOrderFlag()) &&
                !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue().equals(bean.getOrderFlag()) &&
                !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.S.getValue().equals(bean.getOrderFlag()) &&
                !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(bean.getOrderFlag())) {
            MesException.throwMesBusiException(String.format("工单标识为【%s】请选择 【%s】、【%s】、【%s】、【%s】 标识",
                    bean.getOrderFlag(), MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue()
                    , MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue(),
                    MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.S.getValue(),
                    MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue()));
        }
        //校验VIN号是否重复
        if (!StringUtil.isEmpty(bean.getVinCode())) {
            //校验vin号是否重复
            DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(bean.getOrganizeCode());
            DdlPreparedPack.getStringEqualPack(bean.getVinCode(), "vinCode", ddlPackBean);
            if (baseRDao.isExitByHql(ddlPackBean)) {
                MesException.throwMesBusiException("vin号【%s】重复", bean.getVinCode());
            }
        }

        //排序工单数量为1
        bean.setQty(1d);
        //生成工单号
        bean.setWorkOrderNo(getOrderNo(bean));
        //自动发布
        List<MesWorkOrderPart> orderPartList = autoPublish(bean);
        //顺序号
        bean.setProductSeq(getMaxMesWorkOrderProductSeq(bean));
        //生成客户条码
        bean.setCustSn(getCustSn(bean.getCustPartNo(), bean.getOrganizeCode(), bean.getCreateUser()));
        //生成工单零件 工单装配件
        insertMesWorkOrder(bean, orderPartList);

        //物料名称不存在，从物料信息中获取
        MesPartSap mesPart = mesPartSapService.getMesPartSapByPartNo(bean.getPartNo(), bean.getOrganizeCode());
        bean.setPartName(mesPart.getPartName());
        bean.setUnit(mesPart.getUnit());
        //生产时间新增取当天
        if (StringUtil.isEmpty(bean.getProduceTime())) {
            bean.setProduceTime(TimeTool.getToday());
            bean.setProductTime(bean.getProduceTime());
        }
        bean.setQcStatus(MesExtEnumUtil.PRODUCE_QC_STATUS.QUALIFIED.getValue());
        bean.setUnCompleteQty(bean.getQty());
        bean.setFid(UUID.randomUUID().toString());
        bean.setPullingStatus(MesExtEnumUtil.WORK_ORDER_PULLING_STATUS.NOTCREATE.getValue());
        baseRDao.insert(bean);
        workOrderLogService.saveMesWorkOrderLog(bean,MesExtEnumUtil.WORK_ORDER_LOG_TYPE.INSERT,bean.getQty());
    }

    private void insertUnSortWorkOrder(MesWorkOrder bean, MesWorkCenter mesWorkCenter) {
        ValidatorBean.checkNotNull(bean.getOrderFlag(), "标识不能为空");
        if (Objects.isNull(bean.getQty()) || bean.getQty() <= 0d) {
            MesException.throwMesBusiException("生产数量不能小于等于0");
        }
        //校验产线类型和工单类型是否匹配
        if (!Objects.equals(mesWorkCenter.getCenterType(), MesExtEnumUtil.ORDER_TYPE.UN_SORT.getValue())) {
            MesException.throwMesBusiException("产线【%s】类型为【%s】，请选择非排序产线", mesWorkCenter.getWorkCenterCode(),
                    MesExtEnumUtil.WORK_CENTER_TYPE.valueOfDescription(mesWorkCenter.getCenterType()));
        }
        if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue().equals(bean.getOrderFlag()) &&
                !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue().equals(bean.getOrderFlag()) &&
                !MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(bean.getOrderFlag())) {
            MesException.throwMesBusiException(String.format("工单标识为【%s】请选择 【%s】、【%s】、【%s】 标识",
                    bean.getOrderFlag(), MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.E.getValue()
                    , MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.N.getValue(),
                    MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue()));
        }
        //根据产线代码获取生产组信息
        MesPartProdGroup mesPartProdGroup = getMesPartProdGroup(mesWorkCenter.getOrganizeCode(),mesWorkCenter.getWorkCenterCode());
        if(!Objects.isNull(mesPartProdGroup)){
            bean.setPartProdGroupCode(mesPartProdGroup.getPartProdGroupCode());
            bean.setPartProdGroupName(mesPartProdGroup.getPartProdGroupName());
        }
        bean.setWorkOrderStatus(MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue());
        //非试制单
        if (!MesExtEnumUtil.ORDER_TYPE_IDENTIFICATION.P.getValue().equals(bean.getOrderFlag())) {
            ValidatorBean.checkNotNull(bean.getProductVersion(), "生产版本不能为空");
            //校验物料生产版本是否存在
            MesProductVersion mesProductVersion = getMesProductVersion(bean.getOrganizeCode(), bean.getPartNo(), bean.getProductVersion());
            bean.setErpWorkCenter(mesProductVersion.getWorkCenterCode());
        }
        //物料名称不存在，从物料信息中获取
        MesPartSap mesPart = mesPartSapService.getMesPartSapByPartNo(bean.getPartNo(), bean.getOrganizeCode());
        bean.setPartName(mesPart.getPartName());
        bean.setUnit(mesPart.getUnit());
        //生产时间新增取当天
        if (StringUtil.isEmpty(bean.getProduceTime())) {
            bean.setProduceTime(TimeTool.getToday());
            bean.setProductTime(bean.getProduceTime());
        }
        bean.setQcStatus(MesExtEnumUtil.PRODUCE_QC_STATUS.QUALIFIED.getValue());
        bean.setUnCompleteQty(bean.getQty());
        bean.setFid(UUID.randomUUID().toString());
        bean.setWorkOrderNo(getOrderNo(bean));

        baseRDao.insert(bean);
        workOrderLogService.saveMesWorkOrderLog(bean,MesExtEnumUtil.WORK_ORDER_LOG_TYPE.INSERT,bean.getQty());
    }

    private void insertBtoWorkOrder(MesWorkOrder bean) {
        ValidatorBean.checkNotNull(bean.getPlanStartTime(), "计划开始时间不能为空");
        ValidatorBean.checkNotNull(bean.getPlanEndTime(), "计划结束时间不能为空");
        if (Objects.isNull(bean.getQty()) || bean.getQty() <= 0d) {
            MesException.throwMesBusiException("生产数量不能小于等于0");
        }
        //顺序号
        bean.setProductSeq(getMaxMesWorkOrderProductSeq(bean));
        //生成工单号
        bean.setWorkOrderNo(getOrderNo(bean));
        //自动发布
        autoPublish(bean);
        //物料名称不存在，从物料信息中获取
        MesPartSap mesPart = mesPartSapService.getMesPartSapByPartNo(bean.getPartNo(), bean.getOrganizeCode());
        bean.setPartName(mesPart.getPartName());
        bean.setUnit(mesPart.getUnit());
        //生产时间新增取当天
        if (StringUtil.isEmpty(bean.getProduceTime())) {
            bean.setProduceTime(TimeTool.getToday());
            bean.setProductTime(bean.getProduceTime());
        }
        bean.setQcStatus(MesExtEnumUtil.PRODUCE_QC_STATUS.QUALIFIED.getValue());
        bean.setUnCompleteQty(bean.getQty());
        bean.setFid(UUID.randomUUID().toString());
        //生成WorkOrderSeq
        GenSerialNoModel orderSeqSerialNoModel = new GenSerialNoModel(MesCommonConstant.ORDER_NO_BTO_SEQ);
        List<String> resultList = syncFuncService.syncSerialNo(orderSeqSerialNoModel.organizeCode(bean.getOrganizeCode()), bean.getCreateUser(), bean.getOrganizeCode(), 1).getResultList();
        bean.setWorkOrderSeq(resultList.get(0));
        baseRDao.insert(bean);
        workOrderLogService.saveMesWorkOrderLog(bean,MesExtEnumUtil.WORK_ORDER_LOG_TYPE.INSERT,bean.getQty());
    }

    public void doPcnJobProductReport(List<MesProductionRecord> mesProductionRecordList,List<MesShift> mesShiftList,String organizeCode, String userName ,MesWorkOrder mesWorkOrderDb) {

        //查询物料信息
        DdlPackBean ddlPackBeanPart = DdlPackBean.getDdlPackBean(mesWorkOrderDb.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(mesWorkOrderDb.getPartNo(), "partNo", ddlPackBeanPart);
        MesPart mesPart = mesPartRDao.getByProperty(ddlPackBeanPart);
        if (null == mesPart) {
            MesException.throwMesBusiException("物料【%s】信息不存在", mesWorkOrderDb.getPartNo());
        }

        //查询产线信息
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(mesWorkOrderDb.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(mesWorkOrderDb.getWorkCenterCode(), "workCenterCode", ddlPackBean);
        MesWorkCenter mesWorkCenter = mesWorkCenterRDao.getByProperty(ddlPackBean);
        if (Objects.isNull(mesWorkCenter)) {
            MesException.throwMesBusiException("产线【%s】不存在", mesWorkOrderDb.getWorkCenterCode());
        }
        //获取生产版本
        MesProductVersion mesProductVersion = getMesProductVersion(mesWorkOrderDb.getOrganizeCode(),mesWorkOrderDb.getPartNo(),mesWorkOrderDb.getProductVersion());
        //物料+生产版本获取bom信息
        List<MesBom> mesBoms =  findBomList(mesPart.getOrganizeCode(), mesPart, mesProductVersion.getAlternativePartList());

        //保存数据
//        List<MesProductOffLine> mesProductOffLineList = new ArrayList<>();
//        for (MesBom mesBom : mesBoms) {
//            mesProductOffLineList.add(creatMesProductOffLine(mesWorkOrder, mesProductVersion, sn, mesBom, false));
//        }
//        mesProductOffLineService.insertBatch(mesProductOffLineList);

        //保存数据
        List<MesProductOffLine> mesProductOffLineList = new ArrayList<>();
        MesProductOffLine newMesProductOffLine;
        for (MesProductionRecord produceSn : mesProductionRecordList) {
            for (MesBom mesBom : mesBoms) {
                newMesProductOffLine = new MesProductOffLine();
                newMesProductOffLine.setReportPartNo(mesWorkOrderDb.getPartNo());
                newMesProductOffLine.setReportPartNameRdd(mesWorkOrderDb.getPartName());
                newMesProductOffLine.setItemPartNo(mesBom.getItemPartNo());
                newMesProductOffLine.setItemPartName(mesBom.getItemPartName());
                newMesProductOffLine.setItemQty(mesBom.getItemQty());
                newMesProductOffLine.setAlort(mesProductVersion.getReceiveInventoryPoint());
                newMesProductOffLine.setStgeLoc(mesProductVersion.getShipInventoryPoint());
                newMesProductOffLine.setQty(1d);
                newMesProductOffLine.setReportSn(produceSn.getProductSn());
                newMesProductOffLine.setBomVersion(mesWorkOrderDb.getProductVersion());
                newMesProductOffLine.setSerialNumber(produceSn.getSerialNumber());
                newMesProductOffLine.setUnit(mesBom.getUnit());
                newMesProductOffLine.setItemUnit(mesBom.getItemUnit());
                newMesProductOffLine.setWorkOrderNo(mesWorkOrderDb.getWorkOrderNo());
                newMesProductOffLine.setWorkOrderType(mesWorkOrderDb.getWorkOrderType());
                newMesProductOffLine.setWorkCenterCode(mesWorkOrderDb.getWorkCenterCode());
                newMesProductOffLine.setWorkCellCode(mesWorkOrderDb.getWorkCellCode());
                newMesProductOffLine.setReportType(mesWorkOrderDb.getReportType());
                newMesProductOffLine.setSapWorkCenter(mesWorkOrderDb.getErpWorkCenter());
                newMesProductOffLine.setOrganizeCode(organizeCode);
                newMesProductOffLine.setBomTotalSize(mesBoms.size());

                ConvertBean.serviceModelInitialize(newMesProductOffLine, userName);
                mesProductOffLineList.add(newMesProductOffLine);
            }
        }
        mesProductOffLineRDao.saveAll(mesProductOffLineList);
    }

    @Override
    public void doSendMesWorkOrderToWms(String organizeCode, Integer pageSize, String userName) {
        List<MesWorkOrder> mesWorkOrderListToWms = getMesWorkOrderListToWms(organizeCode, pageSize);
        if (CollectionUtils.isEmpty(mesWorkOrderListToWms)) {
            log.info("工厂：{}不存在未推送的工单", organizeCode);
        }
        //获取物料信息
        Map<String, MesPart> partMap = BeanMapUtilsExt.getBeanMap(mesPartRDao, "partNo", organizeCode, mesWorkOrderListToWms.stream().map(MesWorkOrder::getPartNo).distinct().collect(Collectors.toList()), "物料信息");
        // 根据零件加生产版本分组
        Map<String, List<MesWorkOrder>> mesWorkOrderListToWmsMap = mesWorkOrderListToWms.stream().collect(Collectors.groupingBy(t -> new StringJoiner(MesExtConstWords.COMMA).add(t.getPartNo()).add(t.getProductVersion()).toString()));

        List<MesWorkOrderToWms> mesWorkOrderToWmsList = new ArrayList<>();
        List<String> workOrderNoList = new ArrayList<>();
        for (Map.Entry<String, List<MesWorkOrder>> workOrderMap : mesWorkOrderListToWmsMap.entrySet()) {
            List<MesBom> bomExpendList = null;
            List<MesBom> bomList = null;
            MesProductVersion productVersion = null;
            try {
                productVersion = getMesProductVersion(organizeCode, workOrderMap.getKey().split(MesExtConstWords.COMMA)[0], workOrderMap.getKey().split(MesExtConstWords.COMMA)[1]);
                bomList = findMesBomByPartNoAndBomVersion(workOrderMap.getKey().split(MesExtConstWords.COMMA)[0], organizeCode, productVersion.getAlternativePartList());
            } catch (ImppBusiException e) {
                log.info("工厂：{} 信息{}",organizeCode,e.getErrorDetail());
                continue;
            }
            //数据处理
            for (MesWorkOrder workOrder : workOrderMap.getValue()) {
                mesWorkOrderToWmsList.addAll(mesWorkOrderToWmsService.saveMesWorkOrderToWms(workOrder, bomList, userName, false));
                workOrderNoList.add(workOrder.getWorkOrderNo());
                //BOT工单只拆一层
                try {
                    if (MesExtEnumUtil.ORDER_TYPE.BTO.getValue() == workOrder.getWorkOrderType() && partMap.containsKey(workOrderMap.getKey().split(MesExtConstWords.COMMA)[0])) {
                        bomExpendList = Objects.isNull(bomExpendList) ? findBomList(organizeCode, partMap.get(workOrderMap.getKey().split(MesExtConstWords.COMMA)[0]), productVersion.getAlternativePartList()) : bomExpendList;
                        mesWorkOrderToWmsList.addAll(mesWorkOrderToWmsService.saveMesWorkOrderToWms(workOrder, bomExpendList, userName, true));
                    }else {
                        log.info("工厂：{}BTO工单：{}物料：{}信息不存在", organizeCode, workOrder.getWorkOrderNo(), workOrderMap.getKey().split(MesExtConstWords.COMMA)[0]);
                    }
                } catch (ImppBusiException e) {
                    log.info("工单：{} BOT工单只拆一层异常：{}",workOrder.getWorkOrderNo(),e.getErrorDetail());
                }
            }
        }
        //数据持久化
        mesWorkOrderToWmsService.insertBatch(mesWorkOrderToWmsList);
        //更新工单状态为已同步
        updateMesWorkOrder(organizeCode, userName, workOrderNoList);
    }

    private void updateMesWorkOrder(String organizeCode, String userName, List<String> workOrderNoList) {
        if (StringUtil.isEmpty(organizeCode) || CollectionUtils.isEmpty(workOrderNoList)) return;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        if (workOrderNoList.size() == MesExtConstWords.ONE) {
            DdlPreparedPack.getStringEqualPack(workOrderNoList.get(MesExtConstWords.ZERO), MesExtConstWords.WORK_ORDER_NO, packBean);
        } else {
            DdlPreparedPack.getInPackList(workOrderNoList, MesExtConstWords.WORK_ORDER_NO, packBean);
        }
        baseRDao.updateByPropertiesNoSync(new String[]{"modifyUser", "modifyDatetime", "syncToWms"}, new Object[]{userName, TimeTool.getNowTime(true), CommonEnumUtil.VALID}, packBean);
    }

    public void saveMesWorkOrderLog(MesWorkOrder mesWorkOrder) {
        MesWorkOrderLog workOrderLog = new MesWorkOrderLog();
        BeanUtils.copyProperties(mesWorkOrder, workOrderLog,MesExtConstWords.ID,MesExtConstWords.SYSTEM_SYNC_STATUS);
        mesWorkOrderLogRepository.insert(workOrderLog);
    }

    private List<MesWorkOrder> getMesWorkOrderListToWms(String organizeCode, Integer pageSize) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(Arrays.asList(MesExtEnumUtil.ORDER_STATUS.RELEASE.getValue(),MesExtEnumUtil.ORDER_STATUS.PROCESS.getValue()), "workOrderStatus", packBean);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.FALSE, "syncToWms", packBean);
        DdlPreparedPack.getOrderByPack(new Object[]{CommonEnumUtil.ASC_OR_DESC.ASC.getValue()}, new String[]{"createDatetime"}, packBean);
        return baseRDao.findByHqlTopWhere(packBean, StringUtil.isEmpty(pageSize) ? MesExtConstWords.TEN : pageSize);
    }

    public List<MesBom> findBomList(String organizeCode, MesPart mesPart, String bomVersion) {
        List<MesBom> bomData = new ArrayList<>();
        // 递归展开 BOM
        expendBomChild(organizeCode, mesPart.getPartNo(), bomVersion, bomData);

        if (bomData.size() == 0) {
            MesException.throwMesBusiException("零件号 %s 没找找到 ERP 同步的原始 BOM 数据，请检查接口是否正常！", mesPart.getPartNo());
        }

        Iterator<MesBom> iterator = bomData.iterator();
        while (iterator.hasNext()) {
            MesBom item = iterator.next();
            // 删除虚零件
            if (Objects.equals("X", item.getPartType())) {
                iterator.remove();
            } else {
                item.setPartNo(mesPart.getPartNo());
                item.setPartName(mesPart.getPartName());
            }
        }

        Map<String, MesBom> summaryBomMap = new HashMap<>();

        for (MesBom item : bomData) {
            String key = String.format("%s:%s", item.getPartNo().toUpperCase().trim(),
                    item.getItemPartNo().toUpperCase().trim());
            if (!summaryBomMap.containsKey(key)) {
                summaryBomMap.put(key, item);
            } else {
                MesBom tempItem = summaryBomMap.get(key);
                // 子零件重复的累加数量
                tempItem.setItemQty(MathOperation.add(tempItem.getItemQty(), item.getItemQty()));
            }
        }
        // 返回汇总数据
        return new ArrayList<>(summaryBomMap.values());
    }
    /**
     * 递归展开 BOM
     *
     * @param organizeCode 工厂代码
     * @param partNo       父零件号
     * @param bomData      存放 BOM 数据的集合
     */
    private void expendBomChild(String organizeCode, String partNo, String bomVersion, List<MesBom> bomData) {
        List<MesBom> bomDetails =  findMesBomByPartNoAndBomVersion(partNo, organizeCode, bomVersion);

        for (MesBom item : bomDetails) {
            MesBom newItem = new MesBom();
            BeanUtils.copyProperties(item, newItem);
            // 处理父零件用量不为 1 的情况
            if (newItem.getQty() != 1.0 && newItem.getQty() > 0.0) {
                Double rateQty = MathOperation.div(newItem.getItemQty(), newItem.getQty(), 8);
                newItem.setQty(1.0);
                newItem.setItemQty(rateQty);
            }
            // 加入到 BOM 清单中
            bomData.add(newItem);
            // 如果有子阶，继续递归
            if (Objects.equals("X", item.getPartType())) {
                expendBomChild(organizeCode, newItem.getItemPartNo(), null, bomData);
            }
        }
    }
    public List<MesBom> findMesBomByPartNoAndBomVersion(String partNo, String organizeCode, String bomVersion) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(partNo, "partNo", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(bomVersion, "bomVersion", ddlPackBean);
        DdlPreparedPack.getStringSmallerPack(TimeTool.getNowTime(true), "effStartTime", ddlPackBean);
        DdlPreparedPack.getOrderBy("effStartTime", CommonEnumUtil.ASC_OR_DESC.DESC.getValue(), ddlPackBean);
        List<MesBom> mesBoms = mesBomRDao.findByHqlWhere(ddlPackBean);
        if (org.springframework.util.CollectionUtils.isEmpty(mesBoms)) {
            MesException.throwMesBusiException("物料【%s】生产版本【%s】对应bom信息不存在", partNo, bomVersion);
        }
        MesBom next = mesBoms.iterator().next();
        //如果存在多个bomCode取最新的一个
        return mesBoms.stream().collect(Collectors.groupingBy(t -> t.getBomCode() + t.getEffStartTime())).get(next.getBomCode() + next.getEffStartTime());
    }


    private boolean checkWorkCenterPartRelation(String workCenterCode,String partNo){
        DdlPackBean partRelationPackBean = DdlPackBean.getDdlPackBean(AuthUtil.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(workCenterCode,"workCenterCode", partRelationPackBean);
        DdlPreparedPack.getStringEqualPack(partNo, "partNo", partRelationPackBean);
        int count = partRelationRao.findByHqlWhereCount(partRelationPackBean);
        return count > 0;
    }

    private String getCustSn(String partNo,String organizeCode,String userName){
        Calendar custCalendar = Calendar.getInstance();
        custCalendar.setTime(new Date());
        GenSerialNoModel custGenSerialNoModel= new GenSerialNoModel("WH_CUST_SN_RULE");
        String prefix = partNo.substring(0, partNo.length() - 4);
        String partNo4 = partNo.substring(partNo.length() - 4).toUpperCase();
        custGenSerialNoModel.setPartNo(prefix+partNo4);
        String year = custCalendar.get(Calendar.YEAR)+"";
        custGenSerialNoModel.setYear(year.substring(2));
        custGenSerialNoModel.setDay(String.format("%03d",custCalendar.get(Calendar.DAY_OF_YEAR)));
        List<String> custNumRuleList = syncFuncService.syncSerialNo(custGenSerialNoModel, userName, organizeCode, 1).getResultList();
        // [)>%RS%06%GS%Y,4110000000000X,%GS%P,%GS%12V,545238347,%GS%T1A,A2B4C,%RS%%EOT%
        //截取替换为ascii码
        String snOriginal = custNumRuleList.get(0);
        String[] split = snOriginal.split("%RS%");
        StringBuilder rsStr = new StringBuilder();
        for (int i = 0; i < split.length-1; i++) {
            rsStr.append(split[i]).append((char) 30);
        }
        rsStr.append(split[split.length - 1]);
        StringBuilder gsStr = new StringBuilder();
        String[] split1 = rsStr.toString().split("%GS%");
        for (int i = 0; i < split1.length-1; i++) {
            gsStr.append(split1[i]).append((char) 29);
        }
        gsStr.append(split1[split1.length-1]);
        String[] split2 = gsStr.toString().split("%EOT%");
        return split2[0]+(char)4;
    }

    private List<MesWorkOrderPart> dismantleBom(List<MesBom> bomList, double qty,String organizeCode, String workCellCode, String workOrderNo) {
        List<MesWorkOrderPart> orderPartList = new ArrayList<>();

        //1.根据bomList中的subPartNo 查询零件清单 partList
        List<String> partNoList = bomList.stream().map(MesBom::getItemPartNo).distinct().collect(Collectors.toList());

        List<MesPartSap> partSapList = mesPartSapService.findMesPartSapByPartNoList(partNoList,organizeCode);
        Map<String, MesPartSap> partMap = partSapList.stream().collect(Collectors.toMap(MesPartSap::getPartNo, Function.identity()));

        //2.遍历bomList
        for (MesBom bom : bomList) {
            MesWorkOrderPart orderPart = new MesWorkOrderPart();
            MesPartSap partSap = partMap.get(bom.getItemPartNo());
            if (partSap == null) {
                MesException.throwMesBusiException("工厂【%s】零件号【%s】未查到零件信息", organizeCode, bom.getItemPartNo());
            }
            List<MesWorkOrderPart> orderParts = orderPartList.stream().filter(item -> item.getPartNo().equals(partSap.getPartNo())).collect(Collectors.toList());
            if (!orderParts.isEmpty()) {
                MesWorkOrderPart tempPart = orderParts.get(0);
                tempPart.setItemQty(tempPart.getItemQty() + bom.getItemQty() * qty);
                continue;
            }
            orderPart.setPartName(partSap.getPartName());
            orderPart.setPartNo(partSap.getPartNo());
            orderPart.setItemQty(bom.getItemQty() * qty);
            orderPart.setItemUnit(partSap.getUnit());
            orderPart.setSourceId(bom.getId());
            orderPart.setShippingPartNo(partSap.getPartNo());
            orderPart.setWorkOrderNo(workOrderNo);
            orderPart.setWorkCellCode(workCellCode);
            orderPartList.add(orderPart);
        }
        return orderPartList;
    }

    private List<MesPartPtr> getPartPtrList(String organizeCode,String workCenterCode, List<String> partNoList) {
        DdlPackBean partPtrPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workCenterCode, "workCenterCode", partPtrPackBean);
        DdlPreparedPack.getInPackList(partNoList, "srcPartNo", partPtrPackBean);
        DdlPreparedPack.getStringSmallerPack(TimeTool.getNowTime("yyyy-MM-dd HH:mm:ss"), "startTime", partPtrPackBean);
        DdlPreparedPack.getStringBiggerPack(TimeTool.getNowTime("yyyy-MM-dd HH:mm:ss"), "endTime", partPtrPackBean);
        DdlPreparedPack.getIsNotNull("prtVehicleCount", partPtrPackBean);
        List<MesPartPtr> partPtrList = partPtrRao.findByHqlWhere(partPtrPackBean);
        partPtrList = partPtrList.stream().filter(item -> item.getPrtVehicleCount() != null && item.getPrtVehicleCount() > 0)
                .filter(item-> item.getPrtVehicleCount() > item.getPrtVehicleActualCount())
                .collect(Collectors.toList());
        return partPtrList;
    }

    //根据排序信息PTR零件号 获取 ptr信息
    private List<MesPartPtr> getCustPartPtrList(List<String> ptrInfoList,String organizeCode){
        DdlPackBean partPtrPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(ptrInfoList, "seqInfoPrtPart", partPtrPackBean);
        return partPtrRao.findByHqlWhere(partPtrPackBean);
    }

    private MesPartProdGroup getMesPartProdGroup(String organizeCode, String workCenterCode) {
        if (StringUtil.isEmpty(organizeCode) || StringUtil.isEmpty(workCenterCode)) {
            return null;
        }
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workCenterCode, "workCenterCode", packBean);
        return mesPartProdGroupRDao.getByProperty(packBean);
    }

    private List<MesWorkOrderAssembly> getAssemblyList(String workCenterCode, String vehicleNo, List<MesWorkOrderPart> workOrderPartList, String organizeCode) {
        //TM_BAS_WORK_ORDER_ASSEMBLY_SETTING 对应  mes_prod_rule_sort_cfg 排序生产规则

        List<MesWorkOrderAssembly> workOrderAssemblyList = new ArrayList<>();
        List<String> partNoList = workOrderPartList.stream().map(MesWorkOrderPart::getPartNo).collect(Collectors.toList());
        DdlPackBean prodRuleSortPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workCenterCode, "workCenterCode", prodRuleSortPackBean);
        DdlPreparedPack.getInPackList(partNoList, "assemblyPartNo", prodRuleSortPackBean);
        //查询当前产线的所有排序生产规则--分为当前工单清单的装配件
        List<MesProdRuleSortCfg> sortCfgList = mesProdRuleSortCfgRao.findByHqlWhere(prodRuleSortPackBean);
        List<MesProdRuleSortCfg> sortCfgListFilter = sortCfgList.stream().filter(item -> partNoList.contains(item.getAssemblyPartNo())).collect(Collectors.toList());
        Map<String, List<MesWorkOrderPart>> orderPartMap = workOrderPartList.stream().collect(Collectors.groupingBy(MesWorkOrderPart::getPartNo));
        //遍历排序生产规则
        for (MesProdRuleSortCfg sortCfg : sortCfgListFilter) {
            List<MesWorkOrderPart> orderPartList = orderPartMap.get(sortCfg.getAssemblyPartNo());
            MesWorkOrderAssembly orderAssembly = new MesWorkOrderAssembly();
            MesWorkOrderPart orderPart = orderPartList.get(0);
            //1.逻辑储量程序sortCfg.isLogicNum
            if ((sortCfg.getIsLogicNum() !=null && sortCfg.getIsLogicNum() == CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue()) && (sortCfg.getLogicNum()!=null && sortCfg.getLogicNum() >0 )){
                Double total = orderPartList.stream().map(MesWorkOrderPart::getItemQty).reduce(Double::sum).get();
                if (!total.equals(sortCfg.getLogicNum())){
                    log.info("零件号:{}的数量:{}对应排序规则{}的逻辑数量:{}不一致",orderPart.getPartNo(),total,sortCfg.getWorkCenterCode(),sortCfg.getLogicNum());
                    continue;
                }
            }
            //2.当排序规则的车型不为空时，则需要与参数匹配，如果不符合 则不加这个装配项
            if (!StringUtils.isEmpty(sortCfg.getVehicleNo()) && !sortCfg.getVehicleNo().equals(vehicleNo)){
                continue;
            }
            orderAssembly.setAssemblyPartNo(sortCfg.getAssemblyPartNo());
            orderAssembly.setAssemblyPartName(sortCfg.getAssemblyPartName());
            orderAssembly.setProcessName(sortCfg.getProcessName());
            orderAssembly.setWorkCenterCode(sortCfg.getWorkCenterCode());
            orderAssembly.setDisplayRule(sortCfg.getDisplayRule());
            orderAssembly.setMatchRule(sortCfg.getMatchRule());
            orderAssembly.setMatchType(sortCfg.getMatchType());
            orderAssembly.setPrintType(sortCfg.getPrintType());
            orderAssembly.setProcessCode(sortCfg.getProcessCode());
            orderAssembly.setDisplaySeq(sortCfg.getDisplaySeq());
            orderAssembly.setDisplayValue(sortCfg.getDisplayValue());
            orderAssembly.setProcessSeq(sortCfg.getProcessSeq());
            orderAssembly.setCraftName(sortCfg.getCraftName());
            orderAssembly.setCraftCode(sortCfg.getCraftCode());
            orderAssembly.setRouteSeq(sortCfg.getRouteSeq());
            orderAssembly.setWorkCellCode(sortCfg.getWorkCellCode());
            orderAssembly.setOrderPartId(orderPart.getId().toString());
            orderAssembly.setEquipmentCode(sortCfg.getEquipmentCode());
            orderAssembly.setReportType(sortCfg.getReportType());
            if (sortCfg.getReportType() != null && sortCfg.getReportType() == MesExtEnumUtil.MES_REPORT_TYPE.REPORT.getValue()){
                orderAssembly.setReportStatus(MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_30.getValue());
            }else {
                orderAssembly.setReportStatus(MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_10.getValue());
            }
            orderAssembly.setReportPartNo(sortCfg.getReportPartNo());
            orderAssembly.setImageFileId(sortCfg.getImageFileId());
            orderAssembly.setCraftCode(sortCfg.getCraftCode());
            orderAssembly.setCraftName(sortCfg.getCraftName());
            orderAssembly.setPartTypeCode(sortCfg.getPartTypeCode());
            orderAssembly.setShowColor(sortCfg.getShowColor());
            orderAssembly.setProductPartNo(sortCfg.getProductPartNo());
            orderAssembly.setPid(sortCfg.getId());
            orderAssembly.setWorkCenterCode(workCenterCode);
            orderAssembly.setPreCraftCode(sortCfg.getPreCraftCode());
            workOrderAssemblyList.add(orderAssembly);
        }

        //车型不为空的逻辑--用于报工
        DdlPackBean reportRuleSortPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workCenterCode, "workCenterCode", reportRuleSortPackBean);
        DdlPreparedPack.getStringEqualPack(vehicleNo, "vehicleNo", reportRuleSortPackBean);
        DdlPreparedPack.getNotInPackList(partNoList, "assemblyPartNo", reportRuleSortPackBean);
        //查询当前产线的所有排序生产规则--分为当前工单清单的装配件
        List<MesProdRuleSortCfg> prodCfgList = mesProdRuleSortCfgRao.findByHqlWhere(reportRuleSortPackBean);
        for (MesProdRuleSortCfg ruleSortCfg : prodCfgList) {
            MesWorkOrderAssembly orderAssembly = new MesWorkOrderAssembly();
            orderAssembly.setAssemblyPartNo(ruleSortCfg.getAssemblyPartNo());
            orderAssembly.setAssemblyPartName(ruleSortCfg.getAssemblyPartName());
            orderAssembly.setProcessName(ruleSortCfg.getProcessName());
            orderAssembly.setWorkCenterCode(ruleSortCfg.getWorkCenterCode());

            orderAssembly.setDisplayRule(ruleSortCfg.getDisplayRule());
            orderAssembly.setMatchRule(ruleSortCfg.getMatchRule());
            orderAssembly.setMatchType(ruleSortCfg.getMatchType());
            orderAssembly.setPrintType(ruleSortCfg.getPrintType());
            orderAssembly.setProcessCode(ruleSortCfg.getProcessCode());
            orderAssembly.setWorkCellCode(ruleSortCfg.getWorkCellCode());
            orderAssembly.setProcessCode(ruleSortCfg.getProcessCode());
            orderAssembly.setProcessName(ruleSortCfg.getProcessName());
            orderAssembly.setCraftCode(ruleSortCfg.getCraftCode());
            orderAssembly.setRouteSeq(ruleSortCfg.getRouteSeq());
            orderAssembly.setEquipmentCode(ruleSortCfg.getEquipmentCode());
            orderAssembly.setReportType(ruleSortCfg.getReportType());
            if (ruleSortCfg.getReportType() != null && ruleSortCfg.getReportType() == MesExtEnumUtil.MES_REPORT_TYPE.REPORT.getValue()){
                orderAssembly.setReportStatus(MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_30.getValue());
            }else {
                orderAssembly.setReportStatus(MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_10.getValue());
            }
            orderAssembly.setReportPartNo(ruleSortCfg.getReportPartNo());
            orderAssembly.setProcessSeq(ruleSortCfg.getProcessSeq());
            orderAssembly.setPid(ruleSortCfg.getId());
            orderAssembly.setImageFileId(ruleSortCfg.getImageFileId());
            orderAssembly.setPartTypeCode(ruleSortCfg.getPartTypeCode());
            orderAssembly.setMaxValue(ruleSortCfg.getMaxValue());
            orderAssembly.setMinValue(ruleSortCfg.getMinValue());
            orderAssembly.setProductPartNo(ruleSortCfg.getProductPartNo());
            orderAssembly.setPreCraftCode(ruleSortCfg.getPreCraftCode());
            workOrderAssemblyList.add(orderAssembly);
        }
        //查询所有共用的零件 且没有零件号，多用于螺钉---查询排序加工规则
        DdlPackBean prodRuleSortPublicPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workCenterCode, "workCenterCode", prodRuleSortPublicPackBean);
        DdlPreparedPack.getIsNull("assemblyPartNo", prodRuleSortPublicPackBean);
        List<MesProdRuleSortCfg> ruleSortCfgs = mesProdRuleSortCfgRao.findByHqlWhere(prodRuleSortPublicPackBean);
        for (MesProdRuleSortCfg ruleSortCfg : ruleSortCfgs) {
            MesWorkOrderAssembly orderAssembly = new MesWorkOrderAssembly();
            orderAssembly.setAssemblyPartNo(ruleSortCfg.getAssemblyPartNo());
            orderAssembly.setAssemblyPartName(ruleSortCfg.getAssemblyPartName());
            orderAssembly.setProcessName(ruleSortCfg.getProcessName());
            orderAssembly.setWorkCenterCode(ruleSortCfg.getWorkCenterCode());
            orderAssembly.setDisplayRule(ruleSortCfg.getDisplayRule());
            orderAssembly.setMatchRule(ruleSortCfg.getMatchRule());
            orderAssembly.setMatchType(ruleSortCfg.getMatchType());
            orderAssembly.setPrintType(ruleSortCfg.getPrintType());
            orderAssembly.setProcessCode(ruleSortCfg.getProcessCode());
            orderAssembly.setWorkCellCode(ruleSortCfg.getWorkCellCode());
            orderAssembly.setProcessCode(ruleSortCfg.getProcessCode());
            orderAssembly.setProcessName(ruleSortCfg.getProcessName());
            orderAssembly.setCraftCode(ruleSortCfg.getCraftCode());
            orderAssembly.setRouteSeq(ruleSortCfg.getRouteSeq());
            orderAssembly.setEquipmentCode(ruleSortCfg.getEquipmentCode());
            orderAssembly.setReportType(ruleSortCfg.getReportType());
            if (ruleSortCfg.getReportType() != null && ruleSortCfg.getReportType() == MesExtEnumUtil.MES_REPORT_TYPE.REPORT.getValue()){
                orderAssembly.setReportStatus(MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_30.getValue());
            }else {
                orderAssembly.setReportStatus(MesExtEnumUtil.REPORT_STATUS.REPORT_STATUS_10.getValue());
            }
            orderAssembly.setReportPartNo(ruleSortCfg.getReportPartNo());
            orderAssembly.setProcessSeq(ruleSortCfg.getProcessSeq());
            orderAssembly.setPid(ruleSortCfg.getId());
            orderAssembly.setImageFileId(ruleSortCfg.getImageFileId());
            orderAssembly.setPartTypeCode(ruleSortCfg.getPartTypeCode());
            orderAssembly.setMaxValue(ruleSortCfg.getMaxValue());
            orderAssembly.setMinValue(ruleSortCfg.getMinValue());
            orderAssembly.setProductPartNo(ruleSortCfg.getProductPartNo());
            orderAssembly.setPreCraftCode(ruleSortCfg.getPreCraftCode());
            workOrderAssemblyList.add(orderAssembly);
        }
        return workOrderAssemblyList;
    }

    private void insertBatchWorkOrder(MesWorkOrder workOrder, Double generateQty) {
        //查询数据
        List<MesWorkOrderAssembly> orderAssemblyList = mesWorkOrderAssemblyService.findMesWorkOrderAssembly(workOrder.getWorkOrderNo(), workOrder.getOrganizeCode());
        List<MesWorkOrderPart> orderPartList = mesWorkOrderPartService.findMesWorkOrderPart(workOrder.getWorkOrderNo(), workOrder.getOrganizeCode());
        List<MesWorkOrderLog> orderLogList = workOrderLogService.findMesWorkOrderLog(workOrder.getWorkOrderNo(), workOrder.getOrganizeCode());
        List<MesQueueOrder> queueOrderList = findMesQueueOrder(workOrder.getWorkOrderNo(), workOrder.getOrganizeCode());
        MesProduceSn mesProduceSn = mesProduceSnService.getMesProduceSnByCustSn(workOrder.getOrganizeCode(), workOrder.getCustSn());
        MesPrintQueue printQueue = getMesPrintQuanOrder(workOrder.getOrganizeCode(), workOrder.getCustSn());
        //数据处理
        List<MesWorkOrder> newWrkOrderList = new ArrayList<>();
        List<MesWorkOrderAssembly> newOrderAssemblyList = new ArrayList<>();
        List<MesWorkOrderPart> newOrderPartList = new ArrayList<>();
        List<MesWorkOrderLog> newOrderLogList = new ArrayList<>();
        List<MesProduceSn> newProduceSnList = new ArrayList<>();
        List<MesQueueOrder> newQueueOrderList = new ArrayList<>();
        List<MesPrintQueue> newPrintQueueList = new ArrayList<>();
        MesWorkOrderAssembly newOrderAssembly = null;
        MesWorkOrderPart newOrderPart = null;
        MesWorkOrderLog orderLog = null;
        MesProduceSn newProduceSn = null;
        MesQueueOrder newQueueOrder = null;
        MesPrintQueue newPrintQueue = null;
        for (int i = 1; i < generateQty; i++) {
            //工单
            MesWorkOrder newWorkOrder = new MesWorkOrder();
            BeanUtils.copyProperties(workOrder, newWorkOrder, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
            newWorkOrder.setWorkOrderNo(getOrderNo(newWorkOrder));
            newWorkOrder.setProductSeq(newWorkOrder.getProductSeq() + i);
            newWorkOrder.setCustSn(getCustSn(workOrder.getCustPartNo(), workOrder.getOrganizeCode(), workOrder.getCreateUser()));
            newWorkOrder.setFid(UUID.randomUUID().toString());
            newWrkOrderList.add(newWorkOrder);
            //
            //工单装配件
            if (!CollectionUtils.isEmpty(orderAssemblyList)) {
                for (MesWorkOrderAssembly assembly : orderAssemblyList) {
                    newOrderAssembly = new MesWorkOrderAssembly();
                    BeanUtils.copyProperties(assembly, newOrderAssembly, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
                    newOrderAssembly.setWorkOrderNo(newWorkOrder.getWorkOrderNo());
                    newOrderAssembly.setProductSn(newWorkOrder.getWorkOrderNo());
                    newOrderAssemblyList.add(newOrderAssembly);
                }
            }
            //工单零件
            if (!CollectionUtils.isEmpty(orderPartList)) {
                for (MesWorkOrderPart part : orderPartList) {
                    newOrderPart = new MesWorkOrderPart();
                    BeanUtils.copyProperties(part, newOrderPart, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
                    newOrderPart.setWorkOrderNo(newWorkOrder.getWorkOrderNo());
                    newOrderPartList.add(newOrderPart);
                }
            }
            //生产工单日志
            if (!CollectionUtils.isEmpty(orderLogList)) {
                for (MesWorkOrderLog mesWorkOrderLog : orderLogList) {
                    orderLog = new MesWorkOrderLog();
                    BeanUtils.copyProperties(mesWorkOrderLog, orderLog, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
                    orderLog.setWorkOrderNo(newWorkOrder.getWorkOrderNo());
                    orderLog.setFid(UUID.randomUUID().toString());
                    newOrderLogList.add(orderLog);
                }
            }
            //生产队列主表
            if (!CollectionUtils.isEmpty(queueOrderList)) {
                for (MesQueueOrder queueOrder : queueOrderList) {
                    newQueueOrder = new MesQueueOrder();
                    BeanUtils.copyProperties(queueOrder, newQueueOrder, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
                    newQueueOrder.setCustSn(newWorkOrder.getCustSn());
                    newQueueOrder.setWorkOrderNo(newWorkOrder.getWorkOrderNo());
                    newQueueOrder.setSerialNumber(newWorkOrder.getWorkOrderNo());
                    newQueueOrder.setProductSn(newWorkOrder.getWorkOrderNo());
                    newQueueOrder.setProductSeq(newWorkOrder.getProductSeq());
                    newQueueOrderList.add(newQueueOrder);
                }
            }
            //产品条码表
            if (!Objects.isNull(mesProduceSn)) {
                newProduceSn = new MesProduceSn();
                BeanUtils.copyProperties(mesProduceSn, newProduceSn, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
                newProduceSn.setCustSn(newWorkOrder.getCustSn());
                newProduceSn.setWorkOrderNo(newWorkOrder.getWorkOrderNo());
                newProduceSn.setSerialNumber(newWorkOrder.getWorkOrderNo());
                newProduceSn.setProductSn(newWorkOrder.getWorkOrderNo());
                newProduceSn.setFid(UUID.randomUUID().toString());
                newProduceSnList.add(newProduceSn);
            }
            //装配目视单打印
            if (!Objects.isNull(printQueue)) {
                newPrintQueue = new MesPrintQueue();
                BeanUtils.copyProperties(printQueue, newPrintQueue, MesExtConstWords.ID, MesExtConstWords.SYSTEM_SYNC_STATUS);
                newPrintQueue.setWorkOrderNo(newWorkOrder.getWorkOrderNo());
                newPrintQueueList.add(newPrintQueue);
            }
        }
        //数据持久化
        baseRDao.saveAll(newWrkOrderList);
        if (!CollectionUtils.isEmpty(newOrderAssemblyList)) {
            mesWorkOrderAssemblyService.insertBatch(newOrderAssemblyList);
        }
        if (!CollectionUtils.isEmpty(newOrderPartList)) {
            mesWorkOrderPartService.insertBatch(newOrderPartList);
        }
        if (!CollectionUtils.isEmpty(newOrderLogList)) {
            workOrderLogService.insertBatch(newOrderLogList);
        }
        if (!CollectionUtils.isEmpty(newQueueOrderList)) {
            queueOrderRao.saveAll(newQueueOrderList);
        }
        if (!CollectionUtils.isEmpty(newProduceSnList)) {
            mesProduceSnService.insertBatch(newProduceSnList);
        }
        if (!CollectionUtils.isEmpty(newPrintQueueList)) {
            printQueueRepository.saveAll(newPrintQueueList);
        }
    }

    public List<MesQueueOrder> findMesQueueOrder(String workOrderNo, String organizeCode) {
        if(StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo, "workOrderNo", packBean);
        return queueOrderRao.findByHqlWhere(packBean);
    }

    public void closeMesQueueOrder(String workOrderNo, String organizeCode, String userName) {
        if (StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo, "workOrderNo", packBean);
        queueOrderRao.updateByProperties(new String[]{"modifyUser", "modifyDatetime", "status"}, new Object[]{userName, TimeTool.getNowTime(true), MesExtEnumUtil.QUEUE_ORDER_STATUS.CLOSED.getValue()}, packBean);
    }

    public MesPrintQueue getMesPrintQuanOrder(String workOrderNo, String organizeCode) {
        if(StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo, "workOrderNo", packBean);
        return printQueueRepository.getByProperty(packBean);
    }

    private Long getMaxMesWorkOrderProductSeq(MesWorkOrder bean) {
        DdlPackBean orderPackBean = DdlPackBean.getDdlPackBean(bean.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(bean.getWorkOrderType(), "workOrderType", orderPackBean);
        DdlPreparedPack.getOrderByPack(new Object[]{CommonEnumUtil.ASC_OR_DESC.DESC.getValue()}, new String[]{"productSeq"}, orderPackBean);
        MesWorkOrder workOrder = baseRDao.getByProperty(orderPackBean);
        return Objects.isNull(workOrder) || StringUtils.isEmpty(workOrder.getProductSeq()) ? 0L : workOrder.getProductSeq().toString().endsWith("9") ? workOrder.getProductSeq() + 2L : workOrder.getProductSeq() + 1L;
    }

    private MesProductVersion getMesProductVersion(String organizeCode, String partNo, String productVersion) {
        MesProductVersion mesProductVersion = mesProductVersionService.getMesProductVersionByPartNoAndProductVersion(organizeCode, partNo, productVersion);
        if (Objects.isNull(mesProductVersion)) {
            MesException.throwMesBusiException("物料【%s】生产版本【%s】信息不存在", partNo, productVersion);
        }
        return mesProductVersion;
    }

    private MesProductVersion getMesProductVersion(String organizeCode, String partNo) {
        MesProductVersion mesProductVersion = mesProductVersionService.getMesProductVersionByPartNoAndProductVersion(organizeCode, partNo, null);
        if (Objects.isNull(mesProductVersion)) {
            MesException.throwMesBusiException("物料【%s】生产版本信息不存在", partNo);
        }
        return mesProductVersion;
    }

}
